
/* Smart UI v14.2.60 (2022-08-21) 
Copyright (c) 2011-2022 jQWidgets. 
License: https://htmlelements.com/license/ */ //

/**
 * smartQueryBuilder custom element.
 */
Smart('smart-query-builder', class QueryBuilder extends Smart.BaseElement {
    /**
     * Element's properties
     */
    static get properties() {
        return {
            'allowDrag': {
                value: false,
                type: 'boolean'
            },
            'autoPrompt': {
                value: false,
                type: 'boolean'
            },
            'applyMode': {
                allowValues: ['immediately', 'change'],
                value: 'change',
                type: 'string'
            },
            'customOperations': {
                value: [],
                type: 'array',
                reflectToAttribute: false
            },
            'customOperators': {
                value: {},
                type: 'object',
                reflectToAttribute: false
            },
            'dropDownWidth': {
                type: 'any',
                value: 'auto'
            },
            //'disableContextMenu': {
            //    value: false,
            //    type: 'boolean'
            //},
            'fields': {
                value: null,
                type: 'array?',
                reflectToAttribute: false
            },
            'fieldsMode': {
                value: 'dynamic',
                allowedValues: ['dynamic', 'static'],
                type: 'string'
            },
            'formatStringDate': {
                value: 'dd-MMM-yy',
                type: 'string'
            },
            'formatStringDateTime': {
                value: 'dd-MMM-yy HH:mm:ss',
                type: 'string'
            },
            'getDynamicField': {
                value: null,
                type: 'function?'
            },
            'icons': {
                value: {
                    '=': 'equals',
                    '<>': 'notequals',
                    '>': 'greaterthan',
                    '>=': 'greaterthanorequal',
                    '<': 'lessthan',
                    '<=': 'lessthanorequal',
                    'startswith': 'startswith',
                    'endswith': 'endswith',
                    'contains': 'contains',
                    'notcontains': 'notcontains',
                    'isblank': 'isblank',
                    'isnotblank': 'isnotblank'
                },
                type: 'object',
                reflectToAttribute: false
            },
            //'maxConditions': {
            //    value: null,
            //    type: 'number?'
            //},
            //'maxConditionsPerGroup': {
            //    value: null,
            //    type: 'number?'
            //},
            'messages': {
                value: {
                    'en': {
                        'add': 'Add',
                        'addCondition': 'Add Condition',
                        'addGroup': 'Add Group',
                        'and': 'And',
                        'notand': 'Not And',
                        'or': 'Or',
                        'notor': 'Not Or',
                        '=': 'Equals',
                        '<>': 'Does not equal',
                        '>': 'Greater than',
                        '>=': 'Greater than or equal to',
                        '<': 'Less than',
                        '<=': 'Less than or equal to',
                        'startswith': 'Starts with',
                        'endswith': 'Ends with',
                        'contains': 'Contains',
                        'notcontains': 'Does not contain',
                        'isblank': 'Is blank',
                        'isnotblank': 'Is not blank',
                        'wrongParentGroupIndex': '{{elementType}}: Wrong parent group index in "{{method}}" method.',
                        'wrongElementNode': '{{elementType}}: Incorect node / node Id in "{{method}}" method.',
                        'invalidDataStructure': '{{elementType}}: Used invalid data structure in updateCondition/updateGroup method.',
                        'dateTabLabel': 'DATE',
                        'timeTabLabel': 'TIME',
                        'queryLabel': 'Query'
                    }
                },
                type: 'object',
                extend: true
            },
            'operatorPlaceholder': {
                value: 'Operator',
                type: 'string'
            },
            'propertyPlaceholder': {
                value: 'Property',
                type: 'string'
            },
            'showIcons': {
                value: false,
                type: 'boolean'
            },
            'showFieldNameArrow': {
                value: false,
                type: 'boolean'
            },
            'validateOnInput': {
                value: false,
                type: 'boolean'
            },
            'validationTimeout': {
                value: 100,
                type: 'number'
            },
            'value': {
                value: [],
                type: 'any',
                reflectToAttribute: false
            },
            'valueFormatFunction': {
                value: null,
                type: 'function?',
                reflectToAttribute: false
            },
            'valuePlaceholder': {
                value: 'Value',
                type: 'string'
            }
        }
    }

    /**
    *  Required files
    */
    static get requires() {
        const requiredFiles = {
            'Smart.Button': 'smart.button.js',
            'Smart.Calendar': 'smart.calendar.js',
            'Smart.CheckBox': 'smart.checkbox.js',
            'Smart.DateTimePicker': 'smart.datetimepicker.js',
            'Smart.DropDownList': 'smart.dropdownlist.js',
            'Smart.Input': 'smart.input.js',
            'Smart.ListBox': 'smart.listbox.js',
            'Smart.Menu': 'smart.menu.js',
            'Smart.NumericTextBox': 'smart.numerictextbox.js',
            'Smart.ScrollBar': 'smart.scrollbar.js',
            'Smart.TimePicker': 'smart.timepicker.js',
            'Smart.Tooltip': 'smart.tooltip.js',
            'Smart.Utilities.BigNumber': 'smart.math.js',
            'Smart.Utilities.DateTime': 'smart.date.js',
            'Smart.Utilities.Draw': 'smart.draw.js',
            'Smart.Utilities.NumericProcessor': 'smart.numeric.js',
        };

        if (!window.NIComplex) {
            requiredFiles['Smart.Utilities.Complex'] = 'smart.complex.js';
        }

        return requiredFiles;
    }

    /**
     * Element's event listeners.
     */
    static get listeners() {
        return {
            'down': '_downHandler',
            'resize': '_resizeHandler',
            'editorsContainer.keydown': '_editorsContainerKeydownHandler',
            'editorsContainer.keyup': '_editorsContainerKeyUpHandler',
            'conditionsMenu.close': '_menuCloseHandler',
            'conditionsMenu.closing': '_menuClosingHandler',
            'conditionsMenu.itemClick': '_menuItemClickHandler',
            'contentContainer.change': '_contentContainerChangeHandler',
            'contentContainer.itemClick': '_contentContainerChangeHandler',
            'scrollableContainer.touchmove': '_scrollableContainerTouchmoveHandler',
            'document.down': '_documentDownHandler',
            'document.move': '_documentMoveHandler',
            'document.up': '_documentUpHandler'
        }
    }


    /**
    * CSS files needed for the element (ShadowDOM)
    */
    static get styleUrls() {
        return [
            'smart.querybuilder.css'
        ]
    }

    /**
     * Element's HTML template.
     */
    template() {
        return `<div id="container" role="presentation">
                    <smart-scroll-viewer id="scrollableContainer" class="smart-scrollable-container" animation="[[animation]]" right-to-left="[[rightToLeft]]">
                        <div id="queryLabel" class="smart-query-builder-label smart-unselectable"></div>
                        <div id="contentContainer" class="smart-content-container"></div>
                    </smart-scroll-viewer>
                    <div id="editorsContainer" class="smart-editors-container" role="presentation">
                        <div id="customEditor" class="smart-custom-editor smart-hidden"></div>
                    </div>
                    <smart-menu id="conditionsMenu" mode="dropDown" class="smart-conditions-menu" theme="[[theme]]" animation="[[animation]]" right-to-left="[[rightToLeft]]"></smart-menu>
                </div>`;
    }

    /**
   * Updates the element when a property is changed.
   * @param {string} propertyName The name of the property.
   * @param {number/string} oldValue The previously entered value. Max, min and value are of type Number. The rest are of type String.
   * @param {number/string} newValue The new entered value. Max, min and value are of type Number. The rest are of type String.
   */
    propertyChangedHandler(propertyName, oldValue, newValue) {
        super.propertyChangedHandler(propertyName, oldValue, newValue);

        const that = this;

        switch (propertyName) {
            case 'animation':
            case 'theme':
                ['textBoxEditor', 'numericTextBoxEditor', 'comboBoxEditor', 'dateTimePickerEditor', 'checkBoxEditor']
                    .forEach(editor => that.$[editor] && (that.$[editor][propertyName] = newValue));
                break;
            case 'formatStringDate':
            case 'formatStringDateTime':
            case 'valueFormatFunction':
                that._refresh();
                break;
            case 'operatorPlaceholder':
                Array.from((that.shadowRoot || that).querySelectorAll('.smart-filter-operation[placeholder]')).forEach(element => element.firstElementChild.innerHTML = newValue);
                break;
            case 'propertyPlaceholder':
                Array.from((that.shadowRoot || that).querySelectorAll('.smart-filter-field-name[placeholder]')).forEach(element => element.firstElementChild.innerHTML = newValue);
                break;
            case 'showIcons':
                that._closeEditor();

                if (newValue) {
                    that._filterOperationDescriptions.map(item => item.icon = that.icons[item.value]);
                }
                else {
                    that._filterOperationDescriptions.map(item => delete item.icon);
                }

                break;
            case 'customOperations':
            case 'fields':
            case 'value': {
                const oldValueAsString = JSON.stringify(that._validValue),
                    queryParser = that._queryParser;

                if (propertyName === 'customOperations') {
                    that._handleCustomOperations();
                }
                else if (propertyName === '') {
                    that._mapFieldsToMenu();
                }

                that._applyValue();

                if (propertyName === 'customOperations' || propertyName === 'fields') {
                    queryParser[propertyName] = newValue;
                }

                if (that._oldValueAsString !== oldValueAsString) {
                    that._oldValueAsString = JSON.stringify(that._validValue);
                    that.$.fireEvent('change', { value: JSON.parse(that._oldValueAsString), 'linq': queryParser.toLinq(that._validValue) });
                }

                break;
            }
            case 'valuePlaceholder':
                Array.from((that.shadowRoot || that).querySelectorAll('.smart-filter-value[placeholder]')).forEach(element => element.firstElementChild.innerHTML = newValue);
                break;
            case 'locale':
            case 'messages':
                that._localizeInitialValues();
                that._refresh();
                that._handleCustomOperations();//

                if (that.$.dateTimePickerEditor) {
                    if (!that.$.dateTimePickerEditor.messages[that.locale]) {
                        that.$.dateTimePickerEditor.messages[that.locale] = {};
                    }

                    that.$.dateTimePickerEditor.messages[that.locale].dateTabLabel = that.localize('dateTabLabel');
                    that.$.dateTimePickerEditor.messages[that.locale].timeTabLabel = that.localize('timeTabLabel');

                    if (propertyName === 'locale') {
                        that.$.dateTimePickerEditor.locale = that.locale;
                    }
                    else if (propertyName === 'messages') {
                        that.$.dateTimePickerEditor.$.selectDate.innerHTML = that.$.dateTimePickerEditor.messages[that.locale].dateTabLabel;
                        that.$.dateTimePickerEditor.$.selectTime.innerHTML = that.$.dateTimePickerEditor.messages[that.locale].timeTabLabel;
                    }
                }

                break;
            case 'icons':
                that._closeEditor();
                break;
        }
    }

    /**
    * Element's ready method.
    */
    ready() {
        super.ready();

        const that = this;

        if (!that.$.queryLabel.id) {
            that.$.queryLabel.id = that.id + 'Label';
        }

        that.setAttribute('role', 'dialog');
        that.setAttribute('aria-labelledby', that.$.queryLabel.id);

        if (navigator.platform.toLowerCase().lastIndexOf('mac') !== -1) {
            that.$.contentContainer.classList.add('mac');
        }

        //LINQ parser
        that._queryParser = new Smart.Utilities.QueryParser();

        that._setInitialValues();
        that._handleCustomOperations();
        that._applyValue();

        Object.defineProperty(that, 'value', {
            get: function () {
                if (that.context === that) {
                    return that.properties.value.value;
                }
                else {
                    return that._validValue;
                }
            },
            set(value) {
                that.updateProperty(that, that._properties.value, value);
            }
        });
    }

    /**
     * Returns a LINQ representation of the current value
     */
    getLinq() {
        const that = this;

        if (!that._validValue) {
            return;
        }

        that._queryParser.customOperations = that.customOperations;
        that._queryParser.fields = that.fields;
        that._queryParser.dynamicField = that.fieldsMode === 'dynamic' ? that.getDynamicField : undefined;

        // return that._parseQueryToLinq(that._validValue)
        return that._queryParser.toLinq(that._validValue)
    }

    /**
     * Returns false if a invalid value field is present
     * @return - Boolean
     */
    get validationStatus() {
        const that = this;

        if (!that.isReady) {
            return true
        }

        if (that._validationStatus === undefined) {
            return true
        }

        return that._validationStatus
    }

    /**
   * Set default values for the menus
   */
    _setInitialValues() {
        const that = this;

        that._autoScrollCoefficient = Smart.Utilities.Core.Browser.Firefox ? 4 : Smart.Utilities.Core.Browser.Edge ? 8 : 2;
        that._isMobile = Smart.Utilities.Core.isMobile;

        that._manuallyAddedFields = [];
        that._localizeInitialValues();
        that.$.conditionsMenu.dropDownAppendTo = that.$.container;
        that.$.conditionsMenu.dataSource = that._groupOperationDescriptions;

        that._valueFlat = [];
        that._lastProcessedItemInCurrentGroup = { parentId: null, id: null, position: null };
    }

    /**
     * Applies value.
     */
    _applyValue() {
        const that = this;

        that._emptyElementsStructure(true);
        that._validateValue();
        that._convertValueToFlat(that.value);
        that._getFieldsFromValue();
        that._mapFieldsToMenu();
        that._validateValueByType();
        that._generateHTMLStructureFromFlatValue(true);
        that._restrictNesting();
        that._validValue = that._getValidValue();
        that._oldValueAsString = JSON.stringify(that._validValue);
    }

    /**
     * Validates the value field inside the conditions according to the dataType of the field
     */
    _validateValueByType() {
        const that = this;

        if (!that._valueFlat || !that._valueFlat.length) {
            return;
        }

        const items = that._valueFlat;

        for (let i = 0; i < items.length; i++) {
            const item = items[i];

            if (item.type !== 'condition') {
                continue;
            }

            const field = item.data[0];

            if (!field || item.data.length < 3) {
                continue;
            }

            item.data[2] = that._validateStoredValue(item.data[2], field);
        }

        that._generateValue(true);
    }

    /**
     * Applies validation on input or change for boolean oeprators
     * @returns 
     */
    _applyValidationOnInput() {
        const that = this,
            editor = that._editor;

        if (!editor || !that._editorIsOpen) {
            return
        }

        const editedHTMLField = editor.closest('.filter-builder-item'),
            condition = editor.closest('.smart-filter-group-condition');

        if (editedHTMLField && editedHTMLField.classList.contains('smart-filter-value')) {
            clearTimeout(that._valueValidationTimeout);

            that._valueValidationTimeout = setTimeout(() => {
                const nodeId = condition.getAttribute('node-id'),
                    value = that.value.toString();

                clearTimeout(that._valueValidationTimeout);

                that._closeEditor();

                //If the value hasn't been re-generated, do it
                if (value === that.value.toString()) {
                    that._generateValue();
                }

                const conditionRow = that._getItemById(nodeId);

                if (conditionRow) {
                    editor.setAttribute('focus', '');
                    that._openEditor(conditionRow.htmlNode.querySelector('.smart-filter-value'));
                }

                delete that._valueValidationTimeout;
            }, that.validationTimeout);
        }
    }

    /**
     * Change event Handler for the ContentContainer
     * @param {any} event
     */
    _contentContainerChangeHandler(event) {
        const that = this,
            eventType = event.type,
            target = event.target,
            editor = that._editor,
            isEditorOpened = that._editorIsOpen,
            applyMode = that.applyMode;

        event.stopPropagation();

        if (eventType === 'change' && that.validateOnInput && isEditorOpened && target === editor) {
            that._applyValidationOnInput();
        }

        if (eventType === 'itemClick' && target.value !== event.detail.label ||
            applyMode !== 'immediately' || !isEditorOpened || !editor || applyMode === 'immediately' && target !== editor) {
            return;
        }

        const editedHTMLField = that._editor.closest('.filter-builder-item');

        if (!editedHTMLField.classList.contains('smart-filter-value')) {
            that._closeEditor();
            that._handleAutoPrompt(editedHTMLField);
        }
    }

    /**
     * Handles the autoPrompt property
     */
    _handleAutoPrompt(editedHTMLField) {
        const that = this;

        if (!editedHTMLField || !(that.autoPrompt && that.applyMode === 'immediately')) {
            return
        }

        if (!editedHTMLField.classList.contains('smart-filter-value')) {
            const filterItem = editedHTMLField.closest('.smart-filter-group-condition') ||
                editedHTMLField.closest('.smart-filter-nested-operator') || editedHTMLField.closest('.smart-filter-group');

            if (!filterItem) {
                return;
            }

            const item = that._getItemById(filterItem.getAttribute('node-id')),
                valueField = filterItem.querySelector('.smart-filter-value');

            if (!item || !valueField) {
                return
            }

            that._clickHandlerFilterButton(editedHTMLField.classList, item.nodeId, valueField);
        }
    }

    /**
    * Map field's data with menu's label and value.
    */
    _mapFieldsToMenu() {
        const that = this;

        if (!that.fields && !that._valueFields) {
            return;
        }

        that._fields = (that.fields || that._valueFields).concat(that._manuallyAddedFields).map(field => {
            return { label: field.label, value: field.dataField, dataType: field.dataType, filterOperations: field.filterOperations, lookup: field.lookup };
        });
    }

    /**
    * Localizes default values for the menus.
    */
    _localizeInitialValues() {
        const that = this;

        that.$.queryLabel.innerHTML = that.localize('queryLabel');

        that._addOptions = [
            { label: that.localize('addCondition'), value: 'addCondition' },
            { label: that.localize('addGroup'), value: 'addGroup' }
        ];

        that._groupOperationDescriptions = [
            { label: that.localize('and'), value: 'and' },
            //{ label: that.localize('notand'), value: 'notand' },
            { label: that.localize('or'), value: 'or' }
            //{ label: that.localize('notor'), value: 'notor' }
        ];

        that._defaultFilterOperationDescriptions = that._filterOperationDescriptions = [
            { label: that.localize('='), value: '=', custom: false },
            { label: that.localize('<>'), value: '<>', custom: false },
            { label: that.localize('>'), value: '>', custom: false },
            { label: that.localize('>='), value: '>=', custom: false },
            { label: that.localize('<'), value: '<', custom: false },
            { label: that.localize('<='), value: '<=', custom: false },
            { label: that.localize('startswith'), value: 'startswith', custom: false },
            { label: that.localize('endswith'), value: 'endswith', custom: false },
            { label: that.localize('contains'), value: 'contains', custom: false },
            { label: that.localize('notcontains'), value: 'notcontains', custom: false },
            { label: that.localize('isblank'), value: 'isblank', custom: false },
            { label: that.localize('isnotblank'), value: 'isnotblank', custom: false }
        ];

        //TODO: To Be moved to _formatValueStringRepresentation
        const localizedNames = Smart.Utilities.DateTime.getLocalizedNames(that.locale);

        that._localizedDays = localizedNames.days;
        that._localizedMonths = localizedNames.months;
    }

    /**
    * Add custom operations to the menu's operations list
    */
    _handleCustomOperations() {
        const that = this;

        that._filterOperationDescriptions = that._defaultFilterOperationDescriptions.slice(0);

        for (let i = 0; i < that.customOperations.length; i++) {
            let operation = that.customOperations[i],
                existingOperationIndex = that._filterOperationDescriptions.findIndex(op => op.value === operation.name),
                newOperation = {
                    label: operation.label,
                    value: operation.name,
                    custom: true,
                    index: i,
                    editorTemplate: operation.editorTemplate,
                    valueTemplate: operation.valueTemplate,
                    handleValue: operation.handleValue,
                    hideValue: operation.hideValue,
                    validateValue: operation.validateValue
                };

            if (existingOperationIndex > -1) {
                that._filterOperationDescriptions[existingOperationIndex] = newOperation;
                continue;
            }

            that._filterOperationDescriptions.push(newOperation);
        }
    }

    /**
   * InnerContainer keydown eventHandler
   * @param {any} event
   */
    _editorsContainerKeydownHandler(event) {
        const that = this;

        if (that._editorIsOpen && (event.key === 'Escape' || event.key === 'Enter')) {
            that._closeEditor();

            const editedHTMLField = that._editor.closest('.filter-builder-item');

            if (editedHTMLField && !editedHTMLField.classList.contains('smart-filter-value')) {
                that._handleAutoPrompt(editedHTMLField);
            }
        }
    }

    /**
     * InnerContainer keyup handler 
     * @param {*} event 
     * @returns 
     */
    _editorsContainerKeyUpHandler(event) {
        const that = this,
            editor = that._editor;

        if (!editor || !editor.contains(event.target) || !that._editorIsOpen || !that.validateOnInput) {
            return
        }

        that._applyValidationOnInput();
    }

    /**
     * Document down handler - closes menu and/or editor on click outside of the element
     */
    _documentDownHandler(event) {
        const that = this,
            target = that.shadowRoot || that.isInShadowDOM ? event.originalEvent.composedPath()[0] : event.originalEvent.target;

        if ((target.shadowParent && target.shadowParent.closest('.smart-input-drop-down-menu')) || target.closest('.smart-input-drop-down-menu') || that.$.conditionsMenu.contains(target)) {
            return;
        }

        const isDropDown = target.closest('.smart-drop-down');

        if (target.getRootNode().host === that || target.closest('smart-query-builder') === that || (isDropDown && that.contains(isDropDown.ownerElement))) {
            if (that._isMobile) {
                const currentScroll = that.$.scrollableContainer.scrollTop,
                    currentTop = that.getBoundingClientRect().top;

                setTimeout(function () {
                    if (that.$.scrollableContainer.scrollTop !== currentScroll ||
                        that.getBoundingClientRect().top !== currentTop) {
                        return;
                    }
                    else {
                        const oldContext = that.context;

                        that.context = that;
                        that._clickHandler(event.originalEvent);
                        that.context = oldContext;
                    }
                }, 250);
            }
            else {
                that._clickHandler(event.originalEvent);
            }

            return;
        }

        if (that._editorIsOpen && !that._scrollBarDown) {
            that._closeEditor();
        }

        delete that._scrollBarDown;
    }

    /**
    * Generates HTML structure from flat array and adds/replaces
    * @param {Array} data - contains dataField, operator and value
    */
    _emptyElementsStructure(emptyValueFlat) {
        const that = this,
            contentContainer = that.$.contentContainer;

        while (contentContainer.firstChild) {
            contentContainer.removeChild(contentContainer.firstChild);
        }

        that._valueFlat = emptyValueFlat ? [] : that._valueFlat;
        that._lastProcessedItemInCurrentGroup = { parentId: null, id: null, position: null };
    }

    /**
    * Resize handler
    */
    _resizeHandler() {
        this.$.scrollableContainer.refresh();
    }

    /**
     * Returns the number of all conditions
     */
    _getTotalConditions() {
        return this.getElementsByClassName('smart-filter-group-condition').length;
    }

    /**
     * Parses Dynamic LINQ to QueryBuilder value
     */
    _parseLinqToValue() {
        const that = this,
            queryParser = that._queryParser;

        if (!queryParser) {
            return
        }

        queryParser.customOperations = that.customOperations;
        queryParser.fields = that.fields;
        queryParser.dynamicField = that.fieldsMode === 'dynamic' ? that.getDynamicField : undefined;

        //Builds the final query and sets it as the new value of the element
        that.set('value', queryParser.toValue(that.value))
    }

    /**
     * Validates the structure of the "value" array.
     */
    _validateValue() {
        const that = this;

        if (typeof that.value === 'string') {
            that._parseLinqToValue();
        }

        const value = that.properties.value.value;

        if (!Array.isArray(value) ||
            JSON.stringify(value).replace(/[\[\]]/g, '') === '') {
            that.value = [[[]]];
            return;
        }

        if (value.length === 3 && typeof value[0] === 'string') {
            that.value = [[value]];
        }

        if (Array.isArray(value[0]) && value[0].length === 3 && typeof value[0][0] === 'string') {
            that.value = [value];
        }

        while (typeof value[0] === 'string') {
            value.shift();
        }

        while (typeof value[value.length - 1] === 'string') {
            value.pop();
        }

        that.value.forEach(item => {
            if (Array.isArray(item) && item.length === 0) {
                item.push([]);
            }
        });
    }

    /**
    * Converts value(represented as nested array) to flat array. Used for internal data representation
    * @param {Array} groupData - an array with group data
    * @param {String} nodeId - the id of the current element
    */
    _convertValueToFlat(groupData) {
        const that = this,
            operatorList = ['and', 'or', 'notAnd', 'notOr'];

        if (!groupData) {
            return;
        }

        let totalConditions = 0,
            totalGroups = 0;

        function createItems(groupData, groupIndex) {
            let operator;

            for (let i = 0; i < groupData.length; i++) {
                const data = groupData[i],
                    isDataAnOperator = typeof data === 'string' && (operatorList.indexOf(data) > -1 || that.customOperators[data]);
                let item = { htmlNode: null };

                if (isDataAnOperator) {
                    operator = (that.customOperators[data] || data).trim();
                    continue;
                }

                operator = operator || 'and';

                //Check if condition/group
                if (Array.isArray(data)) {
                    let groupConditions = that._valueFlat.filter(item => item.parentId + '' === groupIndex + '').length;

                    //Check if condition
                    if (!data.find(item => Array.isArray(item))) {

                        if (that.maxConditions && totalConditions >= that.maxConditions || that.maxConditionsPerGroup && groupConditions >= that.maxConditionsPerGroup) {
                            continue;
                        }

                        //Create Operator
                        if (i !== 0) {
                            that._valueFlat.push({ nodeId: groupIndex + '.' + groupConditions, type: 'operator', data: operator, parentId: groupIndex + '' });
                            operator = '';
                            groupConditions++;
                        }

                        //Create Condition
                        item.nodeId = groupIndex + '.' + groupConditions;
                        item.parentId = groupIndex + '';
                        item.type = 'condition';
                        item.data = data;

                        totalConditions++;
                        that._valueFlat.push(item);
                    }
                    else {
                        item.nodeId = (totalGroups += 1) + '';
                        item.type = 'group';
                        item.data = operator;
                        that._valueFlat.push(item);

                        createItems(data, item.nodeId);
                        operator = '';
                    }
                }
            }
        }

        //Empty the flat value
        that._valueFlat = [];
        createItems(groupData, 0);

        delete that._totalGroups;
    }

    /**
    * Generates an array of field objects, used as a backup when fields property is not set
    */
    _getFieldsFromValue() {
        const that = this,
            items = that._valueFlat,
            fieldsNames = [],
            fields = [];

        function getDataType(data) {
            if (typeof data === 'boolean') {
                return 'boolean';
            }

            if (data instanceof Date) {
                if (data.getHours() > 0 || data.getMinutes() > 0 || data.getSeconds() > 0) {
                    return 'dateTime';
                }

                return 'date';
            }

            if (!isNaN(data)) {
                return 'number';
            }

            return 'string';
        }

        for (let i = 0; i < items.length; i++) {
            const item = items[i];

            if (item.type === 'condition') {
                const fieldName = item.data[0];

                if (fieldName && fieldsNames.indexOf(fieldName) === -1) {
                    const fieldElement = { label: fieldName, dataField: fieldName, dataType: getDataType(item.data[2]), format: null };

                    fieldsNames.push(fieldName);
                    fields.push(fieldElement);
                }
            }
        }

        that._valueFields = fields;
    }

    /*
    * Creates new group or condition
    * @param {String} type - 'group' or 'condition'
    * @param {Any} parentGroup - html object or group id
    * @param {Any} data - if type is group - contains group's operator;  if type is condition - dataField, operator and value
    */
    _addElement(type, parentGroup, data, noRefresh) {
        const that = this,
            siblings = that._valueFlat.filter(item => {
                return item.parentId === parentGroup
            });
        let addGroupAtPosition = 0,
            groupSeparator = '';

        data = data || (type === 'group' ? 'or' : []);

        if (siblings.length) {
            let siblingsIndexes = siblings.map(index => {
                const indexPath = index.nodeId.split('.');

                return parseInt(indexPath[indexPath.length - 1]);
            });

            siblingsIndexes = (siblingsIndexes.length === 0) ? [0] : siblingsIndexes;
            addGroupAtPosition = siblingsIndexes.reduce((a, b) => Math.max(a, b)) + 1;
        }

        if (parentGroup && parentGroup.length > 0) {
            groupSeparator = '.';
        }

        let itemId = (parentGroup || '') + groupSeparator + (type === 'group' ? that._valueFlat.filter(item => item.type === 'group').length + 1 : addGroupAtPosition);

        let lastGroupSibling = siblings[0];

        if (siblings.length) {
            for (let s = 0; s < siblings.length; s++) {
                const sibling = siblings[s],
                    siblingIndex = sibling.nodeId.split('.').pop();

                if (parseInt(siblingIndex) > parseInt(lastGroupSibling.nodeId.split('.').pop())) {
                    lastGroupSibling = sibling;
                }
            }
        }
        else {
            lastGroupSibling = that._valueFlat.find(item => item.nodeId === parentGroup);
        }

        let lastGroupSiblingIndex = lastGroupSibling ? that._valueFlat.indexOf(lastGroupSibling) + 1 : that._valueFlat.length;

        if (type === 'condition' && siblings.length > 0) {
            that._valueFlat.splice(lastGroupSiblingIndex, 0, { nodeId: itemId, parentId: parentGroup, type: 'operator', data: ['and'], htmlNode: null });
            itemId = (parentGroup || '') + groupSeparator + (addGroupAtPosition + 1);
            lastGroupSiblingIndex++;
        }

        const itemData = {
            nodeId: itemId,
            parentId: parentGroup,
            type: type,
            data: data,
            htmlNode: null
        },
            autoPrompt = that.autoPrompt;

        if (type === 'condition' && autoPrompt && that._fields.length) {
            const field = that._fields[0];

            if (field) {
                const operations = that._getFilterOperations(field);

                data[0] = field.value || field.label || '';

                if (operations.length) {
                    data[1] = operations[0].value;
                }
            }
        }

        that._valueFlat.splice(lastGroupSiblingIndex, 0, itemData);

        if (type === 'group') {
            that._addElement('condition', itemId, [], true);
        }

        if (!noRefresh) {
            that._refresh();

            if (autoPrompt && itemData.htmlNode) {
                const itemNode = itemData.htmlNode,
                    valueField = itemNode.querySelector('.smart-filter-value');

                if (valueField) {
                    that._clickHandlerFilterButton(itemNode.classList, itemData.nodeId, valueField);
                }
            }
        }
    }

    /**
    * Removes a condition and it's HTML representation
    * @param {Any} elementNode.
    * @param {String} type.
    */
    _deleteElement(elementNode, type) {
        const that = this,
            nodeId = typeof elementNode === 'string' ? elementNode : elementNode.getAttribute('node-id');

        if (!nodeId || nodeId.length === 1) {
            return;
        }

        function deleteOperator(index) {
            const operator = that._valueFlat[index];

            //Remove the nested operator for the condition
            if (operator && operator.type === 'operator') {
                that._valueFlat.splice(index, 1);
                operator.htmlNode.parentElement.removeChild(operator.htmlNode);
                return true;
            }
        }

        function deleteCondition(nodeId) {
            let item,
                indexInGroup = 0,
                groupId = nodeId.split('.');

            groupId.pop();
            groupId = groupId.join('.');

            for (let i = 0; i < that._valueFlat.length; i++) {
                const flatItem = that._valueFlat[i];

                if (flatItem.type !== 'condition') {
                    continue;
                }

                if (flatItem.nodeId === nodeId) {
                    item = flatItem;
                    break;
                }

                if (flatItem.parentId === groupId) {
                    indexInGroup++;
                }
            }

            const itemIndex = that._valueFlat.indexOf(item);

            //Remove the condition
            that._valueFlat.splice(itemIndex, 1);
            //that._totalConditions--;
            item.htmlNode.parentElement.removeChild(item.htmlNode);

            //Remove the operator for the condition
            const isPreviousOperatorRemoved = deleteOperator(itemIndex - 1);

            //If the removed condition was 1st in the group, remove the next nested condition as well
            if (!indexInGroup) {
                deleteOperator(itemIndex - (isPreviousOperatorRemoved ? 1 : 0));
            }

            const groupNode = that._valueFlat.filter(item => item.nodeId === groupId)[0].htmlNode;

            if (groupNode.children[1].childElementCount > 0 && groupNode.children[2].hasAttribute('limit-selection') &&
                !groupNode.children[1].lastElementChild.hasAttribute('limit-selection')) {
                groupNode.children[2].removeAttribute('limit-selection');
            }
        }

        function deleteGroup(nodeId) {
            const item = that._valueFlat.filter(item => nodeId === item.nodeId && item.type === 'group')[0];

            for (let i = 0; i < that._valueFlat.length; i++) {
                const nestedItem = that._valueFlat[i],
                    nestedNodeId = nestedItem.nodeId;

                if (nestedItem.parentId === nodeId) {
                    nestedItem.type === 'group' ? deleteGroup(nestedNodeId) : deleteCondition(nestedNodeId);
                }
            }

            that._valueFlat.indexOf(item) > -1 && that._valueFlat.splice(that._valueFlat.indexOf(item), 1);
            item.htmlNode.parentElement.removeChild(item.htmlNode);
        }

        type === 'group' ? deleteGroup(nodeId) : deleteCondition(nodeId);

        //Delete the group if it's empty
        if (!type || type === 'condition') {
            let groupId = nodeId.split('.');

            groupId.pop();
            groupId = groupId.join('.');

            if (!that._valueFlat.filter(i => i.parentId === groupId).length) {
                if (that._valueFlat.filter(item => item.type === 'group').length > 1) {
                    deleteGroup(groupId);
                }

                //Set the new 0th group
                if (groupId === '0') {
                    const firstGroup = that._valueFlat.find(item => item.type === 'group'),
                        oldGroupId = firstGroup.nodeId;

                    firstGroup.nodeId = '0';
                    firstGroup.htmlNode.setAttribute('node-id', '0');

                    const groupConditions = that._valueFlat.filter(item => item.parentId === oldGroupId);

                    for (let c = 0; c < groupConditions.length; c++) {
                        const con = groupConditions[c];

                        con.parentId = '0';
                        con.nodeId = '0.' + c;
                        con.htmlNode.setAttribute('node-id', con.nodeId);
                    }
                }
            }

            that._generateValue();
        }
    }

    /**
     * Generates a flat structure form HTML
     */
    _generateHTMLStructureFromFlatValue(validation) {
        const that = this,
            fragment = document.createDocumentFragment();

        if (!that._valueFlat || that._valueFlat.length === 0) {
            return;
        }

        //let lastGroup;

        for (let i = 0; i < that._valueFlat.length; i++) {
            const item = that._valueFlat[i],
                customOperation = that.customOperations ? that.customOperations.find(operation => operation.name === item.data[1]) : false,
                parentGroupHTMLcontainer = item.parentId ? (that.shadowRoot || that).querySelector('[node-id="' + item.parentId + '"]').
                    querySelector('.smart-filter-group-condition-container') : that.$.contentContainer;

            if (item.type === 'group') {
                const groupContainerBlock = document.createElement('div'),
                    groupOperator = that.localize(item.data) || '';

                groupContainerBlock.className = 'smart-filter-group';
                groupContainerBlock.innerHTML = '<div class="smart-filter-group-operator" role="button" aria-expanded="false" aria-haspopup="menu">' + groupOperator + '</div>' +
                    '<div class="smart-filter-group-condition-container" role="group"></div>' +
                    '<div class="smart-filter-add-condition-btn" role="button" aria-label="Add condition"><div>' + that.localize('add') + '</div></div>' +
                    '<div class="smart-filter-add-btn" role="button" aria-expanded="false" aria-haspopup="menu" aria-label="Add group"></div>';

                //Set the group operator 'data' attribute
                groupContainerBlock.firstElementChild.data = groupOperator;

                fragment.appendChild(groupContainerBlock);

                groupContainerBlock.setAttribute('node-id', item.nodeId);
                that._valueFlat[i].htmlNode = groupContainerBlock;

                //lastGroup = groupContainerBlock;
            }
            else if (item.type === 'condition') {
                const condition = that._newFilterConditionRow(item.data);

                condition.setAttribute('node-id', item.nodeId);
                fragment.appendChild(condition);
                that._valueFlat[i].htmlNode = condition;

                if (item.data[0] !== undefined && item.data[1] === undefined) {
                    const validOperations = that._getFilterOperations(that._fields.find(field => field.value === item.data[0]));

                    that._handleOnlyOperation(validOperations, item.data, condition);
                }
                else if (['isblank', 'isnotblank'].indexOf(item.data[1]) !== -1 || (customOperation && customOperation.hideValue)) {
                    item.data.splice(2, 1);
                    condition.children[2].classList.add('smart-visibility-hidden');
                }
            }
            else {
                const operator = document.createElement('div');

                operator.className = 'smart-filter-nested-operator';
                operator.setAttribute('node-id', item.nodeId);
                operator.setAttribute('role', 'button');
                operator.setAttribute('aria-expanded', false);
                operator.setAttribute('aria-haspopup', 'menu');
                operator.innerHTML = that.localize(item.data);

                fragment.appendChild(operator);
                that._valueFlat[i].htmlNode = operator;
            }

            parentGroupHTMLcontainer.appendChild(fragment);
        }

        if (validation) {
            that._validateValueAdvanced();
        }

        that.$.scrollableContainer.refresh();
    }

    /**
     * Advanced value validation.
     */
    _validateValueAdvanced() {
        const that = this,
            value = that.value;
        let toRefresh = false,
            toRefreshValue = false,
            consecutiveStrings = 0;

        for (let i = 0; i < value.length; i++) {
            const group = value[i];

            if (typeof group === 'string') {
                continue;
            }

            for (let j = group.length - 1; j >= 0; j--) {
                let item = group[j];

                if (Array.isArray(item) && item.length === 0 && j !== group.length - 1) {
                    group.splice(j, 1);

                    if (j === 0) {
                        group.splice(0, 1);
                    }

                    toRefresh = true;
                }
                else if (typeof item === 'string') {
                    item = item.toLowerCase();
                    consecutiveStrings++;

                    if (consecutiveStrings > 1 || item !== 'and' && item !== 'or') {
                        toRefreshValue = true;
                    }

                    continue;
                }

                consecutiveStrings = 0;
            }
        }

        if (toRefresh) {
            that._emptyElementsStructure(true);
            that._convertValueToFlat(that.value);
            that._generateHTMLStructureFromFlatValue();
        }

        if (toRefreshValue) {
            that._generateValue(true);
        }
    }

    /**
     * Restict nesting in condition groups if a "placeholder" condition is already present.
     */
    _restrictNesting() {
        const that = this,
            addConditionBtns = Array.from(that.getElementsByClassName('smart-filter-add-condition-btn'));

        addConditionBtns.forEach(btn => {
            const lastCondition = btn.previousElementSibling.lastElementChild;

            if (lastCondition && lastCondition.hasAttribute('limit-selection')) {
                btn.setAttribute('limit-selection', '');
            }
        });
    }

    /**
    * Handles click event according to the target's type (filter button, add button, delete button, etc.).
    */
    _clickHandler(event) {
        const that = this,
            target = that.shadowRoot || that.isInShadowDOM ? event.composedPath()[0] : event.target;

        if (that.disabled || !target || !target.closest || (!that._isMobile && event.button !== 0)) {
            return;
        }

        if (that._scrollBarDown) {
            delete that._scrollBarDown;
            return;
        }

        const isTargetADropDown = target.closest('.smart-drop-down'),
            targetIsEditor = (that._editor && that._editor.contains(target) || (isTargetADropDown && (that._editor.contains(isTargetADropDown.ownerElement) ||
                that._editor === isTargetADropDown.ownerElement))) || target.closest('.smart-custom-editor');

        if (that._editor && that._editorIsOpen && !targetIsEditor) {
            that._closeEditor();
        }

        const filterItem = target.closest('.smart-filter-group-condition') || target.closest('.smart-filter-nested-operator') || target.closest('.smart-filter-group');

        if (!filterItem) {
            return;
        }

        const item = that._getItemById(filterItem.getAttribute('node-id'));

        if (!item) {
            return;
        }

        that.$.fireEvent('itemClick', {
            id: item.nodeId,
            type: item.type,
            data: item.data
        });

        if (target.closest('.smart-filter-delete-btn')) {
            that._clickHandlerDeleteButton(item.htmlNode);
            return;
        }

        const isAddButton = target.closest('.smart-filter-add-btn') || target.closest('.smart-filter-add-condition-btn');

        //Add group
        if (isAddButton) {
            const selectedFilterGroupId = isAddButton.closest('.smart-filter-group').getAttribute('node-id');

            if (isAddButton.classList.contains('smart-filter-add-condition-btn') && ((that.maxConditions && (that._getTotalConditions() < that.maxConditions)) || !that.maxConditions)) {
                that._addElement('condition', selectedFilterGroupId, []);
                //that._totalConditions++;
            }
            else {
                that._clickHandlerFilterButton(isAddButton.classList, item.nodeId, target);
            }

            return;
        }

        const isFilterButton = target.closest('.filter-builder-item') || target.closest('.smart-filter-group-operator') || target.closest('.smart-filter-nested-operator');

        if (isFilterButton) {
            const elementClassList = isFilterButton.classList;

            that._clickHandlerFilterButton(elementClassList, item.nodeId, target);
        }
    }

    /**
     * down handler
     */
    _downHandler(event) {
        const that = this;

        if (!event.originalEvent || (!that._isMobile && event.button !== 0)) {
            return;
        }

        const target = that.shadowRoot || that.isInShadowDOM ? event.originalEvent.composedPath()[0] : event.originalEvent.target,
            isDraggingPossible = that.rightToLeft ? (event.pageX > target.getBoundingClientRect().right) : (event.pageX < target.getBoundingClientRect().left);

        if (that.allowDrag && target.classList.contains('smart-filter-group-condition') && isDraggingPossible) {
            const conditions = that._valueFlat.filter(item => item.type === 'condition');

            if (conditions.length === 1 ||
                conditions.length === 2 && conditions[0].parentId === conditions[1].parentId &&
                conditions[1].htmlNode.hasAttribute('limit-selection')) {
                return;
            }

            that._dragDetails = {
                coords: {
                    x: event.pageX, y: event.pageY
                },
                item: target,
                originalEvent: event
            };

            that.$.scrollableContainer._scrollView.disableSwipeScroll = true;
            that._hoveredCondition = target;
            window.getSelection().removeAllRanges();
            return;
        }

        this._scrollBarDown = target.closest('smart-scroll-bar');

        event.stopPropagation();
        event.preventDefault();
    }

    /**
     * scrollableContainer touchmove handler.
     */
    _scrollableContainerTouchmoveHandler(event) {
        if (this._dragDetails && event.cancelable) {
            event.preventDefault();
            event.stopPropagation();
        }
    }

    /**
     * document move handler.
     */
    _documentMoveHandler(event) {
        const that = this,
            dragDetails = that._dragDetails;

        if (!dragDetails) {
            return;
        }

        const draggedItem = dragDetails.item;

        if (!dragDetails.feedbackShown) {
            if (Math.abs(dragDetails.coords.x - event.pageX) > 5 ||
                Math.abs(dragDetails.coords.y - event.pageY) > 5) {
                const draggedItemData = that._valueFlat.filter(item => item.htmlNode === draggedItem)[0],
                    dragStartEvent = that.$.fireEvent('dragStart', { data: draggedItemData.data, item: draggedItem, originalEvent: event });

                if (dragStartEvent.defaultPrevented) {
                    delete that._dragDetails;
                    delete that._hoveredCondition;
                    that.$.scrollableContainer._scrollView.disableSwipeScroll = false;
                    return;
                }

                dragDetails.allConditions = Array.from((that.shadowRoot || that).querySelectorAll('.smart-filter-group-condition'));
                dragDetails.data = draggedItemData;
                dragDetails.feedback = that._addDragFeedback();
                dragDetails.feedbackShown = true;

                draggedItem.classList.add('dragged');
            }
            else {
                return;
            }
        }

        const y = event.clientY;
        let target = that.shadowRoot || that.isInShadowDOM ? event.originalEvent.composedPath()[0] : event.originalEvent.target,
            hoveredItem;

        that.$.fireEvent('dragging', { data: dragDetails.data, item: draggedItem, originalEvent: event });
        that.setAttribute('dragging', '');

        dragDetails.feedback.style.left = (event.pageX + 10) + 'px';
        dragDetails.feedback.style.top = (event.pageY + 10) + 'px';

        if (that._isMobile) {
            const oldHoveredItem = that._hoveredCondition;

            if (oldHoveredItem) {
                oldHoveredItem.classList.remove('drop-target', 'top', 'bottom');
                delete that._hoveredCondition;
            }

            const realTarget = document.elementFromPoint(event.clientX, y);

            if (realTarget) {
                target = realTarget;
            }
        }

        let closestCondition = target.closest('.smart-filter-group-condition'),
            side;

        if (closestCondition) {
            hoveredItem = closestCondition;

            const rect = hoveredItem.getBoundingClientRect(),
                topDistance = Math.abs(y - rect.top),
                bottomDisatnce = Math.abs(y - rect.bottom);

            side = topDistance < bottomDisatnce ? 'top' : 'bottom';
        }
        else {
            let closest, closestDistance;

            dragDetails.allConditions.forEach(condition => {
                const rect = condition.getBoundingClientRect(),
                    topDistance = Math.abs(y - rect.top),
                    bottomDisatnce = Math.abs(y - rect.bottom),
                    bestDistance = Math.min(topDistance, bottomDisatnce);

                if (closestDistance === undefined || bestDistance < closestDistance) {
                    closest = condition;
                    closestDistance = bestDistance;
                    side = topDistance < bottomDisatnce ? 'top' : 'bottom';
                }
            });

            closestCondition = closest;
        }

        if (closestCondition !== draggedItem && !(closestCondition.hasAttribute('limit-selection') && side === 'bottom')) {
            const conditionsInGroup = Array.from(closestCondition.parentElement.getElementsByClassName('smart-filter-group-condition')),
                indexOfDraggedItem = conditionsInGroup.indexOf(draggedItem);

            if (indexOfDraggedItem !== -1) {
                if (side === 'top' && closestCondition === conditionsInGroup[indexOfDraggedItem + 1] ||
                    side === 'bottom' && closestCondition === conditionsInGroup[indexOfDraggedItem - 1]) {
                    closestCondition = undefined;
                }
            }
        }
        else {
            closestCondition = undefined;
        }

        hoveredItem = closestCondition;
        dragDetails.side = side;

        clearInterval(that._dragInterval);
        that._dragInterval = setInterval(function () {
            const rect = that.getBoundingClientRect();

            if (that.$.scrollableContainer.scrollHeight > 0 &&
                rect.left <= event.clientX && rect.left + rect.width >= event.clientX) {
                if (y >= rect.top && y <= rect.top + 36) {
                    that.$.scrollableContainer.scrollTop -= that._autoScrollCoefficient;
                }
                else if (y >= rect.top + rect.height - 36 && y <= rect.top + rect.height) {
                    that.$.scrollableContainer.scrollTop += that._autoScrollCoefficient;
                }
                else {
                    clearInterval(that._dragInterval);
                }
            }
            else {
                clearInterval(that._dragInterval);
            }
        }, 1);

        if (hoveredItem) {
            if (that._hoveredCondition && hoveredItem !== that._hoveredCondition) {
                that._hoveredCondition.classList.remove('drop-target', 'top', 'bottom');
            }

            const hoveredItemGroup = hoveredItem.closest('.smart-filter-group');

            if (hoveredItemGroup && hoveredItemGroup.hasAttribute('restricted')) {
                that._hoveredCondition = undefined;
                return;
            }

            that._hoveredCondition = hoveredItem;
            hoveredItem.classList.remove('top', 'bottom');
            hoveredItem.classList.add(side, 'drop-target');
        }
        else if (that._hoveredCondition) {
            that._hoveredCondition.classList.remove('drop-target', 'top', 'bottom');
            delete that._hoveredCondition;
        }
    }

    /**
     * Adds drag feedback.
     */
    _addDragFeedback() {
        const that = this,
            feedback = document.createElement('div');

        that.rightToLeft ? feedback.setAttribute('right-to-left', '') : feedback.removeAttribute('right-to-left');

        feedback.className = 'smart-query-builder-drag-feedback';

        if (that.theme) {
            feedback.setAttribute('theme', that.theme);
        }

        document.body.appendChild(feedback);
        return feedback;
    }

    /**
     * document move handler.
     */
    _documentUpHandler(event) {
        const that = this,
            dragDetails = that._dragDetails;

        if (!dragDetails) {
            if (that.$.conditionsMenu.opened && that._selectedElement && !that._selectedElement.classList.contains('smart-filter-add-btn')) {
                that.$.conditionsMenu._hoverViaKeyboard(that.$.conditionsMenu.querySelector('smart-menu-item[value="' + that._editedItem.data + '"]'));
            }

            return;
        }

        const draggedItem = dragDetails.item,
            draggedItemData = dragDetails.data,
            hoveredItem = that._hoveredCondition;

        delete that._dragDetails;
        delete that._hoveredCondition;
        that.$.scrollableContainer._scrollView.disableSwipeScroll = false;

        if (!that.hasAttribute('dragging')) {
            return;
        }

        clearInterval(that._dragInterval);
        window.getSelection().removeAllRanges();
        that.removeAttribute('dragging');
        draggedItem.classList.remove('dragged');
        dragDetails.feedback.remove();

        if (!hoveredItem) {
            that.$.fireEvent('dragEnd', { data: draggedItemData.data, item: draggedItem, originalEvent: event, target: null, targetData: null, targetSide: null });
            return;
        }

        const hoveredItemData = that._valueFlat.filter(item => item.htmlNode === hoveredItem)[0],
            dragEndEvent = that.$.fireEvent('dragEnd', {
                data: draggedItemData.data,
                item: draggedItem,
                originalEvent: event,
                target: hoveredItem,
                targetData: hoveredItemData.data,
                targetSide: dragDetails.side
            });

        hoveredItem.classList.remove('drop-target', 'top', 'bottom');

        if (dragEndEvent.defaultPrevented) {
            return;
        }

        const value = that.value,
            draggedPath = draggedItemData.nodeId.split('.').map(index => parseFloat(index)),
            groupInValue = value[(draggedPath[0] - 1) * 2],
            hoveredPath = hoveredItemData.nodeId.split('.').map(index => parseFloat(index)),
            targetGroupInValue = value[(hoveredPath[0] - 1) * 2];
        let operator = 'and';

        if (groupInValue.length > 1) {
            if (draggedPath[1] === 0) {
                // condition is first in group
                operator = groupInValue[1];
                groupInValue[1] = '!remove!';
            }
            else {
                // condition is not first in group
                operator = groupInValue[draggedPath[1] - 1];
                groupInValue[draggedPath[1] - 1] = '!remove!';
            }
        }

        groupInValue[draggedPath[1]] = '!remove!';

        if (dragDetails.side === 'top') {
            targetGroupInValue.splice(hoveredPath[1], 0, draggedItemData.data, operator);
        }
        else {
            targetGroupInValue.splice(hoveredPath[1] + 1, 0, operator, draggedItemData.data);
        }

        for (let i = 0; i < value.length; i++) {
            if (Array.isArray(value[i])) {
                value[i] = value[i].filter(member => member !== '!remove!');
            }
        }

        for (let i = value.length - 1; i >= 0; i--) {
            if (Array.isArray(value[i]) && value[i].length === 0) {
                if (i === 0) {
                    value.splice(0, 2);
                }
                else {
                    value.splice(i - 1, 2);
                    i--;
                }
            }
        }

        that._emptyElementsStructure(true);
        that._convertValueToFlat(value);
        that._generateHTMLStructureFromFlatValue();
        that._validValue = that._getValidValue();

        const oldValueAsString = JSON.stringify(that._validValue);

        if (that._oldValueAsString !== oldValueAsString) {
            that._oldValueAsString = oldValueAsString;
            that.$.fireEvent('change', { value: JSON.parse(oldValueAsString), 'linq': that._queryParser.toLinq(that._validValue) });
        }
    }

    /**
    * Handling click on delete button
    */
    _clickHandlerDeleteButton(item, isEmptyCheck) {
        const that = this;

        if (!item || !item.classList) {
            return;
        }

        that._closeEditor();

        if (that.getElementsByClassName('smart-filter-group-condition').length === 1) {
            // resets only condition
            const containers = that._valueFlat[1].htmlNode.children;

            that.value = [[[]]];
            that._validValue = that._getValidValue();

            that._valueFlat[1].data = [];
            that._valueFlat[1].htmlNode.setAttribute('limit-selection', '');
            containers[0].setAttribute('placeholder', '');
            containers[1].setAttribute('placeholder', '');
            containers[2].setAttribute('placeholder', '');
            containers[2].removeAttribute('invalid-value');
            containers[0].firstElementChild.innerHTML = that.propertyPlaceholder;
            containers[1].firstElementChild.innerHTML = that.operatorPlaceholder;
            containers[2].firstElementChild.innerHTML = that.valuePlaceholder;

            const oldValueAsString = JSON.stringify(that._validValue);

            if (that._oldValueAsString !== oldValueAsString) {
                that._oldValueAsString = oldValueAsString;
                that.$.fireEvent('change', { value: JSON.parse(oldValueAsString), 'linq': that._queryParser.toLinq(that._validValue) });
            }

            that._restrictNesting();
            return;
        }

        if (item.classList.contains('smart-filter-group')) {
            if (isEmptyCheck && that._valueFlat.filter(conditionItem => conditionItem.parentId === item.getAttribute('node-id')).length > 0) {
                return;
            }

            that._deleteElement(item, 'group');
        }
        else {
            that._deleteElement(item);
        }

        that._generateValue();
        that.$.scrollableContainer.refresh();

        Array.from(that.$.contentContainer.children).forEach((filterGroup, index) => {
            const parentId = (index + 1).toString();

            filterGroup.setAttribute('node-id', parentId);
            that._valueFlat.filter(item => item.htmlNode === filterGroup)[0].nodeId = parentId;

            Array.from(filterGroup.children[1].children).forEach((element, index) => {
                const valueFlatItem = that._valueFlat.filter(item => item.htmlNode === element)[0],
                    id = parentId + '.' + index;

                element.setAttribute('node-id', id);
                valueFlatItem.parentId = parentId;
                valueFlatItem.nodeId = id;
            });
        });
    }

    /**
     * Handles menu closing.
     */
    _menuCloseHandler() {
        const that = this,
            button = that.$.conditionsMenu.controlledBy;

        button.setAttribute('aria-expanded', false);
        button.removeAttribute('aria-controls');
        delete that.$.conditionsMenu.controlledBy;
    }

    /**
     * Handles menu closing.
     */
    _menuClosingHandler(event) {
        const detail = event.detail;

        if (detail.trigger === 'interaction' && this._selectedElement === detail.target) {
            event.preventDefault();
        }
    }

    /**
     * Handles menu item click.
     */
    _menuItemClickHandler(event) {
        const that = this,
            selectedElement = that._selectedElement.closest('.smart-filter-group-operator, .smart-filter-nested-operator'),
            details = event.detail,
            value = details.value;
        let nodeId;

        if (selectedElement) {
            selectedElement.innerHTML = that.localize(value) || details.label;
            selectedElement.value = value;

            if (selectedElement.classList.contains('smart-filter-nested-operator')) {
                nodeId = selectedElement.getAttribute('node-id');
            }
            else {
                nodeId = selectedElement.parentElement.getAttribute('node-id');
            }

            for (let i = 0; i < that._valueFlat.length; i++) {
                if (that._valueFlat[i].nodeId === nodeId) {
                    that._valueFlat[i].data = selectedElement.value;
                    break;
                }
            }

            that._generateValue();
        }
        else {
            nodeId = that._selectedElement.parentElement.getAttribute('node-id');
            that._addElement('group', null, value);
        }

        that.$.scrollableContainer.refresh();
    }

    /**
    * Creates new filter condition row
    * @param {Array} condition (optional). An array with a condition params. If "condition" parameter is not set - in the method is used default value
    */
    _newFilterConditionRow(condition = []) {
        const that = this,
            dataField = condition[0];
        let dataFieldWithLabel = that._fields.find(item => item.value === dataField),
            dataFieldsLabel = dataFieldWithLabel ? dataFieldWithLabel.label : undefined;
        let operation;

        if (dataField === undefined || !dataFieldsLabel && that.fieldsMode === 'static') {
            condition.length = 0;
        }
        else {
            if (!dataFieldsLabel) {
                dataFieldWithLabel = that._getDynamicFieldInfo(dataField);
                dataFieldsLabel = dataFieldWithLabel.label;
                condition[0] = dataFieldWithLabel.dataField;
            }

            const validOperations = that._getFilterOperations(dataFieldWithLabel);

            operation = validOperations.find(validOperation => validOperation.value === condition[1]);

            if (operation) {
                operation = operation.label;
            }
        }

        const value = that._formatValueStringRepresentation(condition[2], condition),
            //Validate the value if it's a customOperation on initialization
            isValueValid = that._validateValueField(undefined, condition[1], condition[2]);

        let conditionRow = document.createElement('div'),
            id = 'condition' + Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1),
            template = '<div class="filter-builder-item smart-filter-field-name" id="' + id + 'Field" ' + (dataFieldsLabel ? '><div class="smart-value-container" role="presentation">' + dataFieldsLabel : 'placeholder><div class="smart-value-container" role="presentation">' + that.propertyPlaceholder) + '</div></div>' +
                '<div class="filter-builder-item smart-filter-operation" id="' + id + 'Operation" ' + (operation ? '><div class="smart-value-container" role="presentation">' + operation : 'placeholder><div class="smart-value-container" role="presentation">' + that.operatorPlaceholder) + '</div></div>' +
                '<div class="filter-builder-item smart-filter-value" id="' + id + 'Value" ' + (!isValueValid ? 'invalid-value' : '') +
                (condition[2] !== undefined ? '><div class="smart-value-container" role="presentation">' + value : 'placeholder><div class="smart-value-container" role="presentation">' + that.valuePlaceholder) + '</div></div>' +
                '<div class="smart-filter-delete-btn" role="button" aria-label="Close"></div>';


        conditionRow.className = 'smart-filter-group-condition';
        conditionRow.setAttribute('role', 'group');

        conditionRow.innerHTML = template;
        that._setAriaLabel(conditionRow);

        if (!condition.length) {
            conditionRow.setAttribute('limit-selection', '');
        }

        return conditionRow;
    }

    /**
     * Sets the WAI-ARIA property aria-label
     */
    _setAriaLabel(conditionRow) {
        const label = [];

        for (let i = 0; i < conditionRow.children.length - 1; i++) {
            const child = conditionRow.children[i];

            if (!child.classList.contains('smart-visibility-hidden') &&
                !child.hasAttribute('placeholder')) {
                label.push(conditionRow.children[i].innerText);
            }
        }

        if (label.length === 0) {
            conditionRow.setAttribute('aria-label', 'Empty condition row');
            return;
        }

        conditionRow.setAttribute('aria-label', label.join(' '));
    }

    /**
    * Removes a condition and it's HTML representation
    * @param {Any} value.
    * @param {String} field.
    */
    _formatValueStringRepresentation(label, data) {
        const that = this,
            value = data[2],
            field = data[0],
            fieldData = that._getFieldByFieldName(field);
        let valueFormattedByType,
            operation = data[1];

        if (!fieldData || !fieldData.dataType) {
            return label;
        }

        if (label === undefined || label === null) {
            return that.valuePlaceholder;
        }

        if (operation !== undefined && that.customOperations && that.customOperations.length > 0) {
            operation = that.customOperations.find(customOperation => customOperation.name === operation);

            if (operation && operation.valueTemplate) {
                return '<span>' + operation.valueTemplate(that._editor, label) + '</span>';
            }
        }

        switch (fieldData.dataType.toLowerCase()) {
            case 'date':
            case 'datetime':
                label = label instanceof Date || typeof label === 'string' || (typeof label === 'number' && !isNaN(label)) ? new Smart.Utilities.DateTime(label) : label;
                label.calendar.days = that._localizedDays;
                label.calendar.months = that._localizedMonths;
                label.calendar.locale = that.locale;
                valueFormattedByType = label.toString(fieldData.dataType === 'date' ? that.formatStringDate : that.formatStringDateTime);
                break;
            case 'array':
                valueFormattedByType = typeof label === 'string' ? label.split(',') : label;
                break;
            case 'object':
                valueFormattedByType = typeof label === 'string' ? label : JSON.stringify(label);
                break;
            case 'number':
                valueFormattedByType = label;
                break;
            case 'boolean':
                valueFormattedByType = !!label;
                break;
            default:
                valueFormattedByType = label + '';

                valueFormattedByType = valueFormattedByType.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').
                    replace(/'/g, '&#39;').replace(/"/g, '&quot;');

                break;

        }

        if (!that.valueFormatFunction) {
            return '<span>' + valueFormattedByType + '</span>';
        }

        const details = {
            label: valueFormattedByType,
            value: value,
            dataField: field,
            dataType: fieldData.dataType || 'string'

        };

        return '<span>' + that.valueFormatFunction(details) + '</span>';
    }

    /**
    * Return field's data by given field name
    * @param {String} fieldName
    */
    _getFieldByFieldName(fieldName) {
        return Object.assign({}, this._fields.find(item => item.value === fieldName));
    }

    /**
    * Refreshes the structure
    */
    _refresh() {
        const that = this;

        that._generateValue();
        that._emptyElementsStructure();
        that._generateHTMLStructureFromFlatValue();
        that._restrictNesting();
    }

    /**
    * Generates the new value of "value" property from flat
    */
    _generateValue(preventEventFiring) {
        const that = this;
        let groupsWithItems = [],
            value = that._valueFlat.slice(0),
            structure = [];

        //Get all condition groups
        for (let i = 0; i < value.length; i++) {
            const item = value[i];
            let group = {};

            if (item.type === 'group') {
                group.nodeId = item.nodeId;
                group.parentId = item.parentId;
                group.data = item.data;
                group.structure = [];
                groupsWithItems.push(group);
            }
        }

        for (let i = 0; i < groupsWithItems.length; i++) {
            const group = groupsWithItems[i];

            for (let g = 0; g < value.length; g++) {
                const item = value[g];

                if (item.parentId === group.nodeId) {
                    if (item.type === 'condition') {
                        const operator = value[g - 1];

                        if (operator && operator.parentId === group.nodeId && operator.type === 'operator') {
                            group.structure.push(operator.data.toString());
                        }

                        group.structure.push(item.data);
                    }
                }
            }
        }

        groupsWithItems = groupsWithItems.filter(item => {
            return (item.structure.length > 0);
        });

        groupsWithItems.sort(function (a, b) {
            return (b.nodeId.split('.').length - a.nodeId.split('.').length);
        });

        for (let i = 0; i < groupsWithItems.length; i++) {
            const currentElement = groupsWithItems[i],
                group = groupsWithItems.filter(item => {
                    return (item.nodeId === currentElement.parentId)
                })[0];

            if (group && group.structure) {
                group.structure.push(currentElement.structure);
                continue;
            }

            if (currentElement.nodeId === '0') {
                structure = structure.concat(currentElement.structure);
                continue;
            }

            //Push the group operator
            if (currentElement.data) {
                if (i > 0) {
                    structure.push(currentElement.data);
                }

                //Concat the group structure
                structure.push(currentElement.structure);
            }
        }

        that.set('value', structure);
        that._validateValue();
        that._validValue = that._getValidValue();
        that._updateValidationStatus();

        if (!preventEventFiring) {
            const oldValueAsString = JSON.stringify(that._validValue);

            if (that._oldValueAsString !== oldValueAsString) {
                that._oldValueAsString = oldValueAsString;
                that.$.fireEvent('change', { value: JSON.parse(oldValueAsString), 'linq': that._queryParser.toLinq(that._validValue) });
            }
        }
    }

    /**
     * Sets the value validation status
     */
    _updateValidationStatus() {
        const that = this,
            customOperations = that.customOperations.filter(i => typeof i.validateValue === 'function'),
            value = that._valueFlat,
            currentValidationStatus = !!that._validationStatus;
        let validationStatus = true;

        for (let i = 0, max = value.length; i < max; i += 1) {
            const condition = value[i];

            if (condition.type !== 'condition') {
                continue;
            }

            const operation = condition.data[1],
                customOperation = customOperations.find(o => o.name === operation);

            if (customOperation && !!customOperation.validateValue(condition.data[2]) === false) {
                validationStatus = false;
                break
            }
        }

        if (that._validationStatus !== validationStatus) {
            const fireEvent = that._validationStatus !== undefined;

            that._validationStatus = validationStatus;

            if (fireEvent) {
                that.$.fireEvent('validationChange', { oldValue: currentValidationStatus, newValue: validationStatus });
            }
        }
    }

    /**
    * Return item's data by given id
    * @param {String} id - item's id (or parent id - demending on the second parameter)
    * @param {Boolean} isParent (optional)  - of the items is searched by parentId
    */
    _getItemById(id, isParent) {
        const that = this,
            matches = that._valueFlat.filter(item => {
                if (isParent) {
                    return item.parentId === id;
                }
                return item.nodeId === id;
            }),
            editedItem = matches.length > 0 ? matches[0] : null;

        return editedItem;
    }

    /**
     * Validates the value that is going to be stored
     */
    _validateStoredValue(storedValue, fieldName) {
        const that = this;

        if (!fieldName && !that._editedItem) {
            return storedValue;
        }

        if (!fieldName) {
            fieldName = that._editedItem.data[0];

            if (!fieldName) {
                return storedValue;
            }
        }

        const field = that._getFieldByFieldName(fieldName),
            dataType = field.dataType;

        if (dataType === undefined) {
            return storedValue + '';
        }

        //Validate the value
        switch (dataType.toLowerCase()) {
            case 'date':
            case 'datetime':
                storedValue = new Smart.Utilities.DateTime(storedValue).toDate();
                break;
            case 'number':
                if (typeof storedValue !== 'number') {
                    storedValue = parseFloat(storedValue);
                }
                break;
            case 'boolean':
                if (typeof storedValue !== 'boolean') {
                    storedValue = !!storedValue;
                }
                break;
            case 'object':
                if (typeof storedValue !== 'object') {
                    storedValue = {};
                }

                break;
            case 'array':
                if (!Array.isArray(storedValue)) {
                    storedValue = [storedValue];
                }
                break;
            default:
                if (typeof storedValue !== 'string') {
                    storedValue += '';
                }
                break;
        }

        return storedValue;
    }

    /**
    * Closes an editor and sets the new value in the value's cotainer
    * @param {Boolean} preventEventFiring (optional).
    */
    _closeEditor(preventEventFiring) {
        const that = this;
        let storedValue;

        if (!that._editedItem || !that._editorIsOpen) {
            return;
        }

        const editedItem = that._editedItem,
            //editedRow = editedItem.htmlNode,
            //nodeId = editedItem.nodeId,
            editedHTMLField = that._editor.closest('.filter-builder-item'),
            editedHTMLvalueContainer = editedHTMLField.querySelector('.smart-value-container'),
            condition = editedHTMLField.parentElement,
            valueContainer = condition.children[2];

        if (that._editor === that.$.dateTimePickerEditor) {
            that._editor._inputChangeHandler();
            storedValue = that._editor.value;

            if (storedValue) {
                storedValue = storedValue.toDate();
            }
        }
        else if (that._editor === that.$.checkBoxEditor) {
            storedValue = that._editor.checked;
        }
        else if (that._editor === that.$.customEditor) {
            if (that._editor) {
                const customNumericTextBoxes = Array.from(that._editor.getElementsByTagName('smart-numeric-text-box'));

                customNumericTextBoxes.forEach(customNumericTextBox => customNumericTextBox._inputBlurHandler());
            }

            storedValue = that._validateStoredValue(that._selectedCustomCondition.handleValue(that._editor));
        }
        else if (that._editor === that.$.numericTextBoxEditor) {
            that._editor._inputBlurHandler();
            storedValue = that._editor.value;
        }
        else if (editedHTMLField.classList.contains('smart-filter-value')) {
            const selectedField = that._getFieldByFieldName(that._editedItem.data[0]);

            if (selectedField.dataType === 'array') {
                storedValue = that._editor.value.split(',');
            }
            else if (selectedField.dataType === 'object') {
                storedValue = JSON.parse(that._editor.value);
            }
            else {
                const editorValue = that._editor.value;

                if (selectedField.lookup && selectedField.lookup.dataSource) {
                    //dataValue is set as a dataSet attribute to the Smart.Input element
                    storedValue = { label: editorValue, value: that._editor.dataset.value || editorValue }
                }
                else {
                    storedValue = editorValue;
                }
            }
        }
        else {
            storedValue = that._editor.value;
        }

        //editedHTMLvalueComponent = editedRow.querySelector('.smart-filter-value'),

        //that._updateValueInFlatArray(nodeId, storedValue, 'value', (valueDataType || 'string'));
        //Converted the new value to the appropriate type


        //Update the condition object with the new value
        if (editedHTMLField.classList.contains('smart-filter-field-name')) {
            if (storedValue.trim() === '') {
                that._hideEditor(editedHTMLField, editedItem.data[0] === undefined);
                return;
            }

            if (condition.hasAttribute('limit-selection')) {
                // "placeholder" condition
                condition.removeAttribute('limit-selection');
                condition.parentElement.nextElementSibling.removeAttribute('limit-selection');
            }

            const existingField = that._fields.find(item => item.label === storedValue),
                oldFieldValue = editedItem.data[0];

            if (existingField) {
                editedItem.data[0] = existingField.value;
            }
            else if (that.fieldsMode === 'dynamic') {
                const dynamicFieldInfo = that._getDynamicFieldInfo(storedValue);

                storedValue = dynamicFieldInfo.label;
                editedItem.data[0] = dynamicFieldInfo.dataField;
            }
            else {
                const targetField = that._fields.find(item => item.value === oldFieldValue);

                if (targetField) {
                    editedHTMLvalueContainer.innerHTML = targetField.label;
                }

                that._hideEditor(editedHTMLField);
                return;
            }

            editedHTMLvalueContainer.innerHTML = storedValue;
            that._handleFieldChange([oldFieldValue, editedItem.data[0]], [valueContainer, editedItem, condition]);
        }
        else if (editedHTMLField.classList.contains('smart-filter-operation')) {
            that._handleOperationChange([editedItem, storedValue, that._editor.$.input.dataValue], [editedHTMLvalueContainer, valueContainer]);
        }
        else {
            let label, value;

            if (typeof storedValue === 'object' && storedValue.value !== undefined) {
                label = storedValue.label;
                value = storedValue.value;

                if (label === undefined) {
                    label = value;
                }
            }
            else {
                label = value = storedValue;
            }

            editedItem.data[2] = value;
            editedHTMLvalueContainer.innerHTML = that._formatValueStringRepresentation(label, editedItem.data);
        }

        //Validate the value if it's a customOperation
        that._validateValueField(valueContainer, editedItem.data[1], editedItem.data[2]);

        that._generateValue(preventEventFiring);
        that._hideEditor(editedHTMLField);
    }

    /**
     * Validates the value if the operation is custom
     * @param {*} valueContainer - the value container. smart-filter-value
     * @param {*} operation - the operation object ( customOperations object)
     * @param {*} value - the actual value
     */
    _validateValueField(valueContainer, operation, value) {
        const that = this,
            customOperations = that.customOperations;
        let isValueValid = true;

        //Reset the value validation
        if (valueContainer) {
            valueContainer.removeAttribute('invalid-value');
        }

        //NOTE: Custom Validation function for customOperations. Expects a boolean
        if (customOperations && customOperations.length > 0) {
            const customOperation = customOperations.find(customOperation => customOperation.name === operation);

            if (customOperation && typeof customOperation.validateValue === 'function') {
                isValueValid = !!customOperation.validateValue(value);

                if (!isValueValid && valueContainer) {
                    //Set an attribute to style the value container
                    valueContainer.setAttribute('invalid-value', '');
                }
            }
        }

        return isValueValid
    }

    /**
     * Gets the info of a dynamic field.
     */
    _getDynamicFieldInfo(value) {
        const that = this,
            dynamicFieldInfo = { label: value, dataField: value, dataType: 'string' };

        if (that.getDynamicField) {
            const customInfo = that.getDynamicField(value);

            if (customInfo.label) {
                dynamicFieldInfo.label = customInfo.label;
            }

            if (customInfo.dataField) {
                dynamicFieldInfo.dataField = customInfo.dataField;
            }

            if (customInfo.dataType) {
                dynamicFieldInfo.dataType = customInfo.dataType;
            }

            if (customInfo.filterOperations &&
                Array.isArray(customInfo.filterOperations) && customInfo.filterOperations.length > 0) {
                dynamicFieldInfo.filterOperations = customInfo.filterOperations;
            }

            if (customInfo.lookup) {
                dynamicFieldInfo.lookup = customInfo.lookup;
            }
        }

        that._manuallyAddedFields.push(dynamicFieldInfo);
        that._mapFieldsToMenu();
        return dynamicFieldInfo;
    }

    /**
     * Handles field change.
     */
    _handleFieldChange(fields, elements) {
        const that = this,
            oldFieldValue = fields[0],
            editedItem = elements[1],
            condition = elements[2],
            valueContainer = elements[0],
            newField = that._fields.find(field => field.value === fields[1]),
            newOperations = that._getFilterOperations(newField),
            propertySelectedCheck = function () {
                if (newField.value !== oldFieldValue) {
                    that.$.fireEvent('propertySelected', { label: newField.label, value: newField.value });
                }
            };

        if (!oldFieldValue || editedItem.data[1] === undefined) {
            that._handleOnlyOperation(newOperations, editedItem.data, condition);
            propertySelectedCheck();
            return;
        }

        const oldField = that._fields.find(field => field.value === oldFieldValue),
            oldFieldType = oldField.dataType,
            newFieldType = newField.dataType;

        if (newField === oldField ||
            newFieldType === oldFieldType && newFieldType !== 'enum' && !newField.filterOperations && !oldField.filterOperations) {
            return;
        }

        const validInNewOperations = !!newOperations.find(operation => operation.value === editedItem.data[1]);

        if (validInNewOperations) {
            if (newFieldType === oldFieldType && newFieldType !== 'enum') {
                return;
            }

            if (newFieldType === 'date' && oldFieldType === 'dateTime' ||
                newFieldType === 'dateTime' && oldFieldType === 'date') {
                // reformat previous value
                valueContainer.firstElementChild.innerHTML = that._formatValueStringRepresentation(editedItem.data);
                propertySelectedCheck();
                return;
            }

            // remove previous value
            editedItem.data.splice(2, 1);
            valueContainer.setAttribute('placeholder', '');
            valueContainer.firstElementChild.innerHTML = that.valuePlaceholder;
            propertySelectedCheck();
            return;
        }

        // remove previous operator and value
        editedItem.data.splice(1, 2);
        condition.children[1].setAttribute('placeholder', '');
        condition.children[1].firstElementChild.innerHTML = that.operatorPlaceholder;
        valueContainer.setAttribute('placeholder', '');
        valueContainer.firstElementChild.innerHTML = that.valuePlaceholder;
        valueContainer.classList.remove('smart-visibility-hidden');

        that._handleOnlyOperation(newOperations, editedItem.data, condition);
        propertySelectedCheck();
    }

    /**
     * Handles change to a field with only one operation.
     */
    _handleOnlyOperation(newOperations, data, condition) {
        const that = this,
            autoPrompt = that.autoPrompt;

        if (newOperations.length === 1 || autoPrompt && that.applyMode === 'immediately' && newOperations.length > 1) {
            const onlyOperation = newOperations[0];

            data[1] = onlyOperation.value;
            condition.children[1].removeAttribute('placeholder', '');
            condition.children[1].firstElementChild.innerHTML = newOperations[0].label;

            if (onlyOperation.value === 'isblank' || onlyOperation.value === 'isnotblank' || onlyOperation.custom && onlyOperation.hideValue) {
                data.splice(2, 1);
                condition.children[2].classList.add('smart-visibility-hidden');
            }
        }
    }

    /**
     * Handles operation change.
     */
    _handleOperationChange(data, elements) {
        const that = this,
            editedItem = data[0],
            storedLabel = data[1],
            storedValue = data[2],
            editedHTMLvalueContainer = elements[0],
            valueContainer = elements[1],
            oldOperation = editedItem.data[1] !== undefined ? that._filterOperationDescriptions.find(item => item.value === editedItem.data[1]) : undefined,
            newOperation = that._filterOperationDescriptions.find(item => item.value === storedValue);

        if (!newOperation || newOperation === oldOperation) {
            return;
        }

        const newOperationValue = newOperation.value;

        editedItem.data[1] = newOperationValue;

        const fieldName = editedItem.data[0],
            operation = editedItem.data[1],
            value = editedItem.data[2];

        editedHTMLvalueContainer.innerHTML = storedLabel;

        if (newOperationValue === 'isblank' || newOperationValue === 'isnotblank' || newOperation.custom && newOperation.hideValue) {
            editedItem.data.splice(2, 1);
            valueContainer.classList.add('smart-visibility-hidden');
        }
        else if (valueContainer.classList.contains('smart-visibility-hidden')) {
            valueContainer.setAttribute('placeholder', '');
            valueContainer.classList.remove('smart-visibility-hidden');
            valueContainer.firstElementChild.innerHTML = that.valuePlaceholder;
        }
        else if (newOperation.custom) {
            //Sets that._editor to the custom editor
            const field = that._getFieldByFieldName(fieldName);

            if (newOperation.editorTemplate) {
                const editorStructure = newOperation.editorTemplate(field.dataType, operation, field);

                if (editorStructure) {
                    that.$.customEditor.innerHTML = '';
                    that.$.customEditor.appendChild(editorStructure);
                }
            }

            if (newOperation.valueTemplate) {
                valueContainer.firstElementChild.innerHTML = newOperation.valueTemplate(that.$.customEditor, value);
            }
            else {
                if (value === undefined) {
                    valueContainer.setAttribute('placeholder', '');
                    valueContainer.firstElementChild.innerHTML = that.valuePlaceholder;
                }
                else {
                    valueContainer.firstElementChild.innerHTML = value;
                }
            }
        }
        else if (value === undefined) {
            editedItem.data.splice(2, 1);
            valueContainer.setAttribute('placeholder', '');
            valueContainer.firstElementChild.innerHTML = that.valuePlaceholder;
        }
        else if (!newOperation.custom) {
            valueContainer.firstElementChild.innerHTML = that._formatValueStringRepresentation(value, editedItem.data);
        }
    }

    /**
     * Hides editor.
     */
    _hideEditor(editedHTMLField, placeholder) {
        const that = this;

        if (placeholder) {
            editedHTMLField.setAttribute('placeholder', '');
        }

        editedHTMLField.removeAttribute('edited');
        that.$.editorsContainer.removeAttribute('open');

        if (that._editor.close) {
            that._editor.close();
        }

        that._editor.classList.add('smart-hidden');
        that._editorIsOpen = that._enterIsPressedInEditor = false;
        that.$.scrollableContainer.refresh();
        that._setAriaLabel(editedHTMLField.parentElement);
    }

    /**
    * Handling click on delete buton
    */
    _clickHandlerFilterButton(elementClassList, itemId, target) {
        const that = this;

        function prepareContextMenu(target, dataSource, selectedItem) {
            that._contextMenuOptions = dataSource.length === 0 ? that._defaultFilterOperationDescriptions : dataSource;
            that._handleContextMenu(target);

            if (that.$.conditionsMenu.opened) {
                that.$.conditionsMenu._discardKeyboardHover();
                that.$.conditionsMenu._hoverViaKeyboard(that.$.conditionsMenu.querySelector('smart-menu-item[value="' + selectedItem + '"]'));
            }
        }

        if (target.closest('.smart-editors-container')) {
            return;
        }

        that._closeEditor();
        that._editedItem = that._getItemById(itemId);

        if (elementClassList.contains('smart-filter-add-btn')) {
            prepareContextMenu(target, that._groupOperationDescriptions);
            return;
        }

        if (!elementClassList.contains('smart-filter-field-name') && (!that._editedItem.data || !that._editedItem.data.length)) {
            return;
        }

        if (elementClassList.contains('smart-filter-group-operator') || elementClassList.contains('smart-filter-nested-operator')) {
            prepareContextMenu(target, that._groupOperationDescriptions, that._editedItem.data);
        }
        else {
            const filterBuilderItem = target.closest('.filter-builder-item');

            filterBuilderItem.removeAttribute('placeholder');

            that._openEditor(target);
        }
    }

    /**
    * Handles context menu position
    * @param {HTML element} target (optional) - the component that is clicked
    */
    _handleContextMenu(target) {
        const that = this;

        if (that._selectedElement === target && that.$.conditionsMenu.opened) {
            that.$.conditionsMenu.close();
            return;
        }

        that._closeEditor();

        if (that.disableContextMenu) {
            that._selectedElement = target;
            return;
        }

        const targetCoordinates = target.getBoundingClientRect(),
            elementCoordinates = that.getBoundingClientRect(),
            x = targetCoordinates.left + that.$.contentContainer.scrollLeft - elementCoordinates.left,
            y = targetCoordinates.top + that.$.contentContainer.scrollTop - elementCoordinates.top + targetCoordinates.height;

        if (target.hasAttribute('aria-haspopup')) {
            if (that.$.conditionsMenu.controlledBy) {
                that.$.conditionsMenu.controlledBy.setAttribute('aria-expanded', false);
                that.$.conditionsMenu.controlledBy.removeAttribute('aria-controls');
            }

            target.setAttribute('aria-controls', that.$.conditionsMenu.id);
            target.setAttribute('aria-expanded', true);
            that.$.conditionsMenu.controlledBy = target;
        }

        that.$.conditionsMenu.dataSource = that._contextMenuOptions;
        that.$.conditionsMenu.open(x, y + 3);
        that._selectedElement = target;
        that.$.scrollableContainer.refresh();
    }

    /**
    * Open an editor at the position of the current editted condition value container
    * @param {Html element} target - the clicked HTML element. Used to be localized element's data and set into editor
    */
    _openEditor(target) {
        const that = this,
            id = target && target.closest('.smart-filter-group-condition') ? target.closest('.smart-filter-group-condition').getAttribute('node-id') : null,
            valueContainer = target.closest('.filter-builder-item'),
            editedItem = that._getItemById(id);
        let field = '';

        if (editedItem.data[0] !== undefined) {
            field = editedItem.data[0];
        }
        else if (that._fields.length) {
            field = that._fields[0].value;
        }

        let fieldData = that._getFieldByFieldName(field),
            value = '', dataValue, filterItemIndex;

        if (valueContainer.classList.contains('smart-filter-field-name')) {
            filterItemIndex = 0;

            if (!that._fields) {
                that._mapFieldsToMenu();
            }

            fieldData.lookup = { dataSource: that._fields.slice(), readonly: false };

            //Note: The 'if' check prevents the editor from getting it's value preset
            // if (editedItem.data[0] === undefined && that.applyMode === 'immediately') {
            //     value = dataValue = '';
            // }
            // else {
            value = fieldData.label || '';
            dataValue = fieldData.value;
            // }
        }
        else if (valueContainer.classList.contains('smart-filter-operation')) {
            filterItemIndex = 1;

            let filteredOptions = that._getFilterOperations(fieldData);

            fieldData.lookup = { dataSource: filteredOptions, readonly: true };

            let correspondingOption = filteredOptions.find(option => option.value === editedItem.data[filterItemIndex]) ||
                filteredOptions[0];

            value = correspondingOption.label;
            dataValue = correspondingOption.value;
        }
        else {
            filterItemIndex = 2;
            value = editedItem.data[filterItemIndex];

            if (value === undefined) {
                value = '';
            }
        }

        if (that._editorIsOpen) {
            that._closeEditor();
        }

        valueContainer.setAttribute('edited', '');
        that._editedItem = editedItem;

        const fields = that._fields,
            fieldItemsMatch = fields.filter(item => {
                return item.value === field;
            }),
            foundCustomConditions = that._filterOperationDescriptions.filter(item => {
                return ((item.value === editedItem.data[1]) && item.custom);
            }),
            fieldItem = fieldItemsMatch.length > 0 ? fieldItemsMatch[0] : null,
            fieldType = (fieldData.lookup && fieldData.lookup.dataSource) ? 'lookup' : (fieldItem ? fieldItem.dataType : undefined);

        if (filterItemIndex !== 2 || foundCustomConditions.length === 0 || !foundCustomConditions[0].editorTemplate) {
            that._openEditorByFieldType(fieldType, value, fieldData, dataValue);
        }
        else {
            that._selectedCustomCondition = foundCustomConditions[0];
            that._openCustomEditor(fieldType, value, fieldData);
        }

        valueContainer.appendChild(that.$.editorsContainer);
        that._editor.classList.remove('smart-hidden');
        that._editorIsOpen = true;
        that.$.editorsContainer.setAttribute('open', '');
        that.$.scrollableContainer.refresh();

        if (that._editor.classList.contains('smart-custom-editor')) {
            const openHandler = that.customOperations[that._selectedCustomCondition.index].onEditorOpen;

            if (openHandler) {
                openHandler(that._editor);
            }
        }
        else {
            requestAnimationFrame(() => that._editor.focus());
        }

        if (fieldData.lookup && !that._valueValidationTimeout) {
            that._editor.open();
        }
    }

    /**
     * Returns filter operations by field.
     */
    _getFilterOperations(fieldData) {
        const that = this;
        let filteredOptions = that._filterOperationDescriptions.slice();

        if (fieldData.filterOperations) {
            filteredOptions = that._filterOperationDescriptions.filter(item => fieldData.filterOperations.indexOf(item.value) > -1);
        }
        else {
            let filterOperationsByType;

            switch (fieldData.dataType) {
                case 'date':
                case 'dateTime':
                case 'number':
                    filterOperationsByType = ['=', '<>', '<', '>', '<=', '>=', 'isblank', 'isnotblank'];
                    break;
                case 'boolean':
                    filterOperationsByType = ['=', '<>', 'isblank', 'isnotblank'];
                    break;
                case 'object':
                    filterOperationsByType = ['isblank', 'isnotblank'];
                    break;
                case 'string':
                    filterOperationsByType = ['contains', 'notcontains', 'startswith', 'endswith', '=', '<>', 'isblank', 'isnotblank'];
                    break;
                default:
                    filterOperationsByType = ['contains', 'notcontains', 'startswith', 'endswith', '=', '<>', '<', '>', '<=', '>=', 'isblank', 'isnotblank'];
                    break;
            }

            filteredOptions = that._filterOperationDescriptions.filter(item => filterOperationsByType.indexOf(item.value) > -1);
        }

        if (that.showIcons) {
            filteredOptions.map(item => item.icon = that.icons[item.value]);
        }

        return filteredOptions;
    }

    /**
     * Open custom editor
     */
    _openCustomEditor(fieldType, value, fieldData) {
        const that = this,
            editorStructure = that.customOperations[that._selectedCustomCondition.index].editorTemplate(fieldType, value, fieldData);

        that.$.customEditor.innerHTML = '';

        if (editorStructure) {
            that.$.customEditor.appendChild(editorStructure);
        }

        that._editor = that.$.customEditor;
    }

    /**
    * Open specific editor, regarding field type settings and set it's value
    * @param {String} fieldType - type of the edited field, each type has different handling
    * @param {Any} value - the value, that must be set to the editor
    */
    _openEditorByFieldType(fieldType, value, fieldData, dataValue) {
        const that = this;

        if (fieldType) {
            switch (fieldType.toLowerCase()) {
                case 'boolean':
                    that._initializeEditor('checkBox');
                    that._editor.checked = !!value;
                    return;
                case 'date':
                case 'datetime':
                    that._initializeEditor('dateTimePicker');
                    that._editor.formatString = fieldType === 'date' ? that.formatStringDate : that.formatStringDateTime;
                    that._editor.value = value;
                    return;
                case 'number':
                    that._initializeEditor('numericTextBox');
                    that._editor.value = value ? value : 0;
                    return;
            }
        }

        that._initializeEditor('input');

        that._editor.dropDownWidth = that.dropDownWidth;

        if (fieldType === 'lookup') {
            const minLength = fieldData.lookup.minLength,
                dataSource = fieldData.lookup.dataSource;

            that._editor.autoCompleteDelay = fieldData.lookup.autoCompleteDelay || 100;
            that._editor.dropDownAppendTo = that.$.container;
            that._editor.dropDownButtonPosition = that.rightToLeft ? 'left' : 'right';
            that._editor.minLength = isNaN(minLength) || minLength === null ? 1 : minLength;
            that._editor.readonly = !!fieldData.lookup.readonly;

            if (typeof dataSource === 'function') {
                that._editor.dataSource = dataSource;
            }
            else if (dataSource instanceof Promise) {
                dataSource.then(response => {
                    if (!(that._editor instanceof Smart.Input)) {
                        return
                    }

                    const isEditorOpened = that._editor.opened;

                    that._editor.dataSource = response;

                    if (response.length < 12) {
                        that._editor.dropDownHeight = 'auto';
                    }
                    else {
                        that._editor.dropDownHeight = 200;
                    }

                    if (isEditorOpened) {
                        that._editor.open();

                        if (value === '' && that._editor.readonly && response.length) {
                            that._editor.value = response[0].label || response[0]
                        }
                    }
                })
            }
            else {
                that._editor.dataSource = dataSource;
                if (dataSource.length < 12) {
                    that._editor.dropDownHeight = 'auto';
                }
                else {
                    that._editor.dropDownHeight = 200;
                }
            }

            if (fieldType === 'object') {
                value = JSON.stringify(value ? value : {});
            }
            else {
                if (value === '' && that._editor.readonly) {
                    const editorDataSource = that._editor.dataSource;

                    if (Array.isArray(editorDataSource)) {
                        const dataItem = editorDataSource[0];

                        value = dataItem ? (dataItem.value || dataItem.label || '') : '';
                    }
                    else {
                        value = '';
                    }
                }
            }

            if (that._editor.isRendered) {
                const dataValue = that._editor.$.input.dataValue;

                if (dataValue === null || dataValue === undefined || dataValue !== value) {
                    that._editor.value = value !== undefined ? (value + '') : '';
                }
            }
            else {
                that._editor.value = value !== undefined ? (value + '') : '';
            }
        }
        else {
            that._editor.dataSource = [];
            that._editor.dropDownButtonPosition = 'none';
            that._editor.readonly = false;
            that._editor.value = value !== undefined ? (value + '') : '';
        }

        if (dataValue && fieldType !== 'object' && that._editor.isRendered) {
            that._editor.$.input.dataValue = dataValue;
        }
    }

    /**
    * Initializes Editors instance if it's not initialized.
    */
    _initializeEditor(editor) {
        const that = this;

        if (that.$[editor + 'Editor']) {
            that._editor = that.$[editor + 'Editor'];
            return;
        }

        const editorElement = document.createElement('smart-' + Smart.Utilities.Core.toDash(editor));

        if (editor === 'numericTextBox') {
            editorElement.spinButtons = true;
            editorElement.inputFormat = 'floatingPoint';
        }
        else if (editor === 'dateTimePicker') {
            editorElement.dropDownAppendTo = that.$.container;
            editorElement.calendarButton = true;
            editorElement.dropDownDisplayMode = 'auto';
            editorElement.enableMouseWheelAction = true;
            editorElement.locale = that.locale;
            editorElement.autoClose = true;

            if (!editorElement.messages[that.locale]) {
                editorElement.messages[that.locale] = {};
            }

            editorElement.messages[that.locale].dateTabLabel = that.localize('dateTabLabel');
            editorElement.messages[that.locale].timeTabLabel = that.localize('timeTabLabel');
        }

        editorElement.rightToLeft = that.rightToLeft;
        editorElement.theme = that.theme;
        editorElement.animation = that.animation;
        editorElement.$.addClass('smart-hidden underlined');

        that.$.editorsContainer.appendChild(editorElement);

        that._editor = that.$[editor + 'Editor'] = editorElement;
    }

    /**
     * Gets the value without invalid or incomplete conditions.
     */
    _getValidValue() {
        const that = this,
            value = that.properties.value.value,
            result = [];
        let emptyGroup = false;

        value.forEach((group) => {
            if (Array.isArray(group)) {
                let groupIsValid = false,
                    emptyCondition = false;
                const groupContent = [];

                group.forEach((condition) => {
                    if (Array.isArray(condition)) {
                        const field = condition[0],
                            operation = condition[1],
                            val = condition[2];

                        if (field === undefined || operation === undefined) {
                            emptyCondition = true;
                            return;
                        }

                        if (val !== undefined || operation === 'isblank' || operation === 'isnotblank') {
                            groupIsValid = true;
                            groupContent.push(condition);
                            return;
                        }

                        const operationInfo = that._filterOperationDescriptions.find(currentOperation => currentOperation.value === operation);

                        if (operationInfo.custom && operationInfo.hideValue) {
                            groupIsValid = true;
                            groupContent.push(condition);
                        }
                        else {
                            emptyCondition = true;
                        }
                    }
                    else if (emptyCondition) {
                        emptyCondition = false;
                    }
                    else {
                        groupContent.push(condition);
                    }
                });

                if (groupIsValid) {
                    if (typeof groupContent[groupContent.length - 1] === 'string') {
                        groupContent.pop();
                    }

                    result.push(groupContent);
                }
                else {
                    emptyGroup = true;
                }
            }
            else if (emptyGroup) {
                emptyGroup = false;
            }
            else {
                result.push(group);
            }
        });

        if (typeof result[result.length - 1] === 'string') {
            result.pop();
        }

        return result;
    }
});

/**
 * QueryBuilder parser, QueryBuilder value to LinQ and LinQ to QueryBuilder value
 */
Smart.Utilities.Assign('QueryParser', class QueryParser {
    constructor(fields, customOperations, dynamicField) {
        const that = this;

        //[object[]] - an array of custom operations. The same as in QeryBuilder
        that.customOperations = customOperations || [];

        //[object[]] - the QueryBuilder fields that will be used to parse the LinQ to query array
        that.fields = fields || [];

        //Function - the QueryBuilder getDynamicField taht returns a dynamic field. Optional
        that.dynamicField = dynamicField;
    }

    /**
     * Returns a LinQ expression based on a valid QueryBuilder value
     */
    toLinq(value) {
        const that = this;

        if (!Array.isArray(value) || !that._arePropertiesValid()) {
            return ''
        }

        return that._parseQueryToLinq(value)
    }

    toValue(linq) {
        const that = this;

        if (typeof linq !== 'string' || !that._arePropertiesValid()) {
            return []
        }

        return that._parseLinqToValue(linq)
    }

    /**
     * Checks whether all property values are valid or not
     */
    _arePropertiesValid() {
        const that = this;

        if (!Array.isArray(that.customOperations)) {
            // eslint-disable-next-line
            console.log('Invalid "customOperations" property.')
            return false
        }
        else if (!Array.isArray(that.fields)) {
            // eslint-disable-next-line
            console.log('Invalid "fields" property.')
            return false
        }

        return true
    }

    /**
   * Builds a Dynamic Linq expression from the value of the element
   * @param {Array} value - an array of objects that construct a valid QueryBuilder value
   */
    _parseQueryToLinq(value) {
        const that = this,
            logicalOperator = {
                'and': '&&',
                'or': '||'
            };
        let queryString = '';

        for (let i = 0; i < value.length; i++) {
            const query = value[i];

            if (Array.isArray(query)) {
                if (query.indexOf('and') > -1 || query.indexOf('or') > -1 || (query.length === 1 && Array.isArray(query[0]))) {
                    const nestedQuery = that._parseQueryToLinq(query);

                    if (nestedQuery) {
                        queryString += query.length > 1 ? '(' + nestedQuery + ')' : nestedQuery;
                    }
                    else if (/\s(&|\|){2}\s$/gm.test(queryString)) {
                        //Remove the unnecessary logical operator for the empty expression
                        queryString = queryString.replace(/\s(&|\|){2}\s$/gm, '');
                    }
                }
                else {
                    queryString += that._getExpressionFromQuery(query) || '';
                }
            }
            else {
                if (queryString) {
                    queryString += ' ' + logicalOperator[query] + ' ';
                }
            }
        }

        return queryString;
    }

    /**
  * Converts the value to Dynamic Linq expression
  * @param {String} query - a LinQ expression
  */
    _getExpressionFromQuery(query) {
        const that = this,
            name = query[0],
            operation = query[1];
        let value = query[2];

        const operator = that.customOperations.find(customOp => customOp.name === operation);

        if (!operator || !operator.expressionTemplate) {
            return '';
        }

        // In the case where a property value has a quotation in it we need to explicitly json
        // the property value so it is a valid dynamic linq expression when built
        if (typeof value === 'string' && value.includes('"') && operator.expressionTemplate.includes('"')) {
            value = JSON.stringify(value).slice(1, -1);
        }

        // Handle building of dynamic linq expression based upon the selected property/operation
        return operator.expressionBuilderCallback ? operator.expressionBuilderCallback(name, operation, value) :
            operator.expressionTemplate.replace('{0}', name).replace('{1}', value)
    }

    /**
     * Parses Dynamic LINQ to QueryBuilder value
     */
    _parseLinqToValue(queryString) {
        const that = this;
        let groupStarted = 0,
            groupStartIndex,
            leafQueries = [];

        //Find the query groups surrounded by brackets
        for (let i = 0; i < queryString.length; i++) {
            if (queryString[i] === '(') {
                groupStarted++;

                if (groupStartIndex === undefined) {
                    groupStartIndex = i;
                }
            }
            else if (queryString[i] === ')' && groupStarted > 0) {
                groupStarted--;

                if (groupStarted === 0) {
                    let group = queryString.substring(groupStartIndex, i + 1).trim();

                    if (group.length && (group.includes('&&') || group.includes('||'))) {
                        leafQueries.push({ expr: group });
                    }

                    groupStartIndex = undefined;
                }
            }
        }

        //Handle any expressions that are not surrounded by brackets ( outher groups )
        let outherGroups = [], previousGroup;

        if (leafQueries.length) {
            for (let g = 0; g < leafQueries.length; g++) {
                let outherGroup;

                leafQueries[g].query = that._getQueryFromExpression(leafQueries[g].expr);

                if (previousGroup) {
                    outherGroup = queryString.substring(queryString.indexOf(previousGroup) + previousGroup.length, queryString.indexOf(leafQueries[g].expr)).trim();
                }
                else {
                    outherGroup = queryString.substring(0, queryString.indexOf(leafQueries[g].expr)).trim();
                }

                if (outherGroup) {
                    outherGroups.push(outherGroup);
                }

                previousGroup = leafQueries[g].expr;
            }
        }

        //Handles outher groups after a subGroup
        if (previousGroup) {
            outherGroups.push(queryString.substring(queryString.indexOf(previousGroup) + previousGroup.length).trim());
        }
        else {
            outherGroups.push(queryString.trim());
        }

        //Handles all outher groups
        for (let i = 0; i < outherGroups.length; i++) {
            const outherGroup = outherGroups[i].replace(/^&{2}|^\|{2}|&{2}$|\|{2}$/gm, '').trim();

            if (outherGroup.length) {
                leafQueries.push({ expr: outherGroup, query: that._getQueryFromExpression(outherGroup), outher: true });
            }
        }

        //Builds the final query and sets it as the new value of the element
        return that._constructValueFromQueries(queryString, leafQueries)
    }

    /**
    * Finds and returns the valid queries in a Linq expressions
    * @param {string} expression - the linq expression
    */
    _getQueryFromExpression(expression) {
        const that = this,
            fields = that.fields,
            dynamicField = that.dynamicField;
        let allQueries = [], expr = expression;
        const getQuery = function (expr) {
            let expressionMatches = [];

            //string check for expresions
            const customOperatorsWithExpressions = that.customOperations.filter(op => op.expressionTemplate);

            //Sort expressions by length, from longest (most complex) to shortest(less complex)
            customOperatorsWithExpressions.sort((a, b) => b.expressionTemplate.length - a.expressionTemplate.length);

            for (let i = 0; i < customOperatorsWithExpressions.length; i++) {
                const operator = customOperatorsWithExpressions[i],
                    expRegex = new RegExp(operator.expressionTemplate.replace(/\(/gm, '\\(').
                        replace(/\)/gm, '\\)').replace(/\[/gm, '\\[').replace(/\]/gm, '\\]').
                        replace(/"{\d+}"/gm, '\\W*"([^"]*)[^a-zA-Z0-9-\\s\\)]+').replace(/{\d+}/gm, '([@|$]*\\w+[.]*\\w+(?!\\s)*)\\s{0}').
                        replace(/ /gm, '\\s'), 'gm');

                if (expRegex.test(expr)) {
                    expRegex.lastIndex = 0;

                    let fieldName, value,
                        match = expRegex.exec(expr);

                    match = match.filter((item, index) => match.indexOf(item) === index);

                    //Custom Expression. Expect an object with fieldName and value
                    if (operator.expressionReaderCallback) {
                        let customArguments = operator.expressionReaderCallback(match[0], match.slice(1));

                        if (customArguments) {
                            fieldName = customArguments.fieldName;
                            value = customArguments.value;
                        }
                    }

                    if (fieldName === undefined) {
                        fieldName = match[1] || '';
                    }

                    if (value === undefined) {
                        value = match[2] || '';
                    }

                    //Collect all expression matches
                    expressionMatches.push({ operator: operator.name, field: fieldName, value: value, query: match[0] });
                    continue
                }
            }

            //Find the corresponding field
            let exprMatch = expressionMatches.find(expMatch => fields.find(field =>
                field.filterOperations.indexOf(expMatch.operator) > -1 && field.dataField === expMatch.field));

            if (!exprMatch && dynamicField) {
                for (let i = 0; i < expressionMatches.length; i++) {
                    const exprObj = expressionMatches[i],
                        field = dynamicField(exprObj.field);

                    if (field && Array.isArray(field.filterOperations) && field.filterOperations.indexOf(exprObj.operator) > -1) {
                        exprMatch = exprObj;
                        break;
                    }
                }
            }

            if (exprMatch) {
                allQueries.push({ expr: exprMatch.query, query: [exprMatch.field, exprMatch.operator, exprMatch.value] });
                return exprMatch.query
            }
        }

        if (!expr) {
            return;
        }

        //Find all valid LinQ expressions and converts them to queries
        while (expr.length) {
            if (expr) {
                expr = expr.trim();

                //Removes the starting/ending brackets
                if (expr[0] === '(' && expr[expr.length - 1] === ')') {
                    expr = expr.trim().replace(/^\(|\)$/gm, '');
                }

                //Removes the logical operators infron and after an expressions
                expr = expr.replace(/^&{2}|^\|{2}|&{2}$|\|{2}$/gm, '').trim();
            }

            //Check for valid expression
            const match = getQuery(expr);

            if (!match) {
                break;
            }

            //Remove the match from the expressions
            expr = expr.replace(match, '').trim();
        }

        //Returns the final query with the logical operators between the groups
        return that._constructValueFromQueries(expression, allQueries);
    }

    /**
     * Constructs the final value from LinQ expression
     */
    _constructValueFromQueries(expression, queries) {
        let newValue = [];

        //Sorts the queries depending on their possition in the expression
        queries.sort((a, b) => {
            return expression.indexOf(a.expr) - expression.indexOf(b.expr)
        });

        //Finds the correct Logical operators between the groups
        for (let i = 0; i < queries.length; i++) {
            let previousExpr = queries[i - 1];

            if (previousExpr) {
                const operator = expression.substring(expression.indexOf(previousExpr.expr) + previousExpr.expr.length, expression.indexOf(queries[i].expr)).trim();

                newValue.push(operator === '||' ? 'or' : 'and');
            }

            if (queries[i].outher) {
                queries[i].query.forEach(q => newValue.push(Array.isArray(q) ? [q] : q));
            }
            else {
                newValue.push(queries[i].query);
            }
        }

        return newValue;
    }
});
